| 1 |
<?php |
| 2 |
/** |
| 3 |
* MainWP REST Controller |
| 4 |
* |
| 5 |
* This class handles the REST API |
| 6 |
* |
| 7 |
* @package MainWP\Dashboard |
| 8 |
*/ |
| 9 |
|
| 10 |
use MainWP\Dashboard\MainWP_DB; |
| 11 |
use MainWP\Dashboard\MainWP_Utility; |
| 12 |
use MainWP\Dashboard\MainWP_Settings; |
| 13 |
use MainWP\Dashboard\MainWP_Notification_Settings; |
| 14 |
use MainWP\Dashboard\MainWP_Settings_Indicator; |
| 15 |
use MainWP\Dashboard\MainWP_System_Utility; |
| 16 |
use MainWP\Dashboard\Module\CostTracker\Cost_Tracker_Utility; |
| 17 |
use MainWP\Dashboard\Module\CostTracker\Cost_Tracker_Admin; |
| 18 |
use MainWP\Dashboard\Module\ApiBackups\Api_Backups_3rd_Party; |
| 19 |
use MainWP\Dashboard\Module\ApiBackups\Api_Backups_Utility; |
| 20 |
use MainWP\Dashboard\MainWP_Keys_Manager; |
| 21 |
use MainWP\Dashboard\MainWP_Api_Manager; |
| 22 |
use MainWP\Dashboard\MainWP_Connect; |
| 23 |
use MainWP\Dashboard\MainWP_Logger; |
| 24 |
use MainWP\Dashboard\MainWP_Sync; |
| 25 |
use MainWP\Dashboard\MainWP_Manage_Sites_View; |
| 26 |
use MainWP\Dashboard\MainWP_Uptime_Monitoring_Handle; |
| 27 |
use MainWP\Dashboard\MainWP_Uptime_Monitoring_Edit; |
| 28 |
use MainWP\Dashboard\MainWP_Credential_Render; |
| 29 |
|
| 30 |
// Exit if accessed directly. |
| 31 |
if ( ! defined( 'ABSPATH' ) ) { |
| 32 |
exit; |
| 33 |
} |
| 34 |
|
| 35 |
|
| 36 |
/** |
| 37 |
* Class MainWP_Rest_Settings_Controller |
| 38 |
* |
| 39 |
* @package MainWP\Dashboard |
| 40 |
*/ |
| 41 |
class MainWP_Rest_Settings_Controller extends MainWP_REST_Controller { //phpcs:ignore -- NOSONAR - multi methods. |
| 42 |
|
| 43 |
// phpcs:disable Generic.Metrics.CyclomaticComplexity -- complexity. |
| 44 |
|
| 45 |
/** |
| 46 |
* Protected static variable to hold the single instance of the class. |
| 47 |
* |
| 48 |
* @var mixed Default null |
| 49 |
*/ |
| 50 |
private static $instance = null; |
| 51 |
|
| 52 |
/** |
| 53 |
* Route base. |
| 54 |
* |
| 55 |
* @var string |
| 56 |
*/ |
| 57 |
protected $rest_base = 'settings'; |
| 58 |
|
| 59 |
/** |
| 60 |
* Batch size. |
| 61 |
* |
| 62 |
* @var int |
| 63 |
*/ |
| 64 |
private static $batch_size = 5; |
| 65 |
|
| 66 |
/** |
| 67 |
* Constructor. |
| 68 |
*/ |
| 69 |
public function __construct() { |
| 70 |
$this->db = MainWP_DB::instance(); |
| 71 |
} |
| 72 |
|
| 73 |
/** |
| 74 |
* Method instance() |
| 75 |
* |
| 76 |
* Create public static instance. |
| 77 |
* |
| 78 |
* @static |
| 79 |
* @return static::$instance |
| 80 |
*/ |
| 81 |
public static function instance() { |
| 82 |
if ( null === static::$instance ) { |
| 83 |
static::$instance = new self(); |
| 84 |
} |
| 85 |
return static::$instance; |
| 86 |
} |
| 87 |
|
| 88 |
/** |
| 89 |
* Method register_routes() |
| 90 |
* |
| 91 |
* Creates the necessary endpoints for the api. |
| 92 |
* Note, for a request to be successful the URL query parameters consumer_key and consumer_secret need to be set and correct. |
| 93 |
*/ |
| 94 |
public function register_routes() { // phpcs:ignore -- NOSONAR - complex. |
| 95 |
// Global settings. |
| 96 |
register_rest_route( |
| 97 |
$this->namespace, |
| 98 |
'/' . $this->rest_base . '/general', |
| 99 |
array( |
| 100 |
array( |
| 101 |
'methods' => WP_REST_Server::READABLE, |
| 102 |
'callback' => array( $this, 'get_general_settings' ), |
| 103 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 104 |
), |
| 105 |
'schema' => array( $this, 'get_public_item_schema' ), |
| 106 |
) |
| 107 |
); |
| 108 |
register_rest_route( |
| 109 |
$this->namespace, |
| 110 |
'/' . $this->rest_base . '/general/edit', |
| 111 |
array( |
| 112 |
'methods' => 'PUT, PATCH', |
| 113 |
'callback' => array( $this, 'update_general_settings' ), |
| 114 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 115 |
'args' => $this->get_update_general_allowed_fields(), |
| 116 |
'validate_callback' => array( $this, 'validate_update_general_params' ), |
| 117 |
), |
| 118 |
); |
| 119 |
|
| 120 |
// Advanced settings. |
| 121 |
register_rest_route( |
| 122 |
$this->namespace, |
| 123 |
'/' . $this->rest_base . '/advanced', |
| 124 |
array( |
| 125 |
array( |
| 126 |
'methods' => WP_REST_Server::READABLE, |
| 127 |
'callback' => array( $this, 'get_advanced_settings' ), |
| 128 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 129 |
), |
| 130 |
) |
| 131 |
); |
| 132 |
register_rest_route( |
| 133 |
$this->namespace, |
| 134 |
'/' . $this->rest_base . '/advanced/edit', |
| 135 |
array( |
| 136 |
array( |
| 137 |
'methods' => 'PUT, PATCH', |
| 138 |
'callback' => array( $this, 'update_advanced_settings' ), |
| 139 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 140 |
'args' => $this->get_update_advanced_allowed_fields(), |
| 141 |
), |
| 142 |
) |
| 143 |
); |
| 144 |
|
| 145 |
// Monitoring settings. |
| 146 |
register_rest_route( |
| 147 |
$this->namespace, |
| 148 |
'/' . $this->rest_base . '/monitoring', |
| 149 |
array( |
| 150 |
array( |
| 151 |
'methods' => WP_REST_Server::READABLE, |
| 152 |
'callback' => array( $this, 'get_monitoring_settings' ), |
| 153 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 154 |
), |
| 155 |
) |
| 156 |
); |
| 157 |
register_rest_route( |
| 158 |
$this->namespace, |
| 159 |
'/' . $this->rest_base . '/monitoring/edit', |
| 160 |
array( |
| 161 |
array( |
| 162 |
'methods' => 'PUT, PATCH', |
| 163 |
'callback' => array( $this, 'update_monitoring_settings' ), |
| 164 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 165 |
'args' => $this->get_update_monitoring_allowed_fields(), |
| 166 |
), |
| 167 |
) |
| 168 |
); |
| 169 |
|
| 170 |
// Email settings. |
| 171 |
register_rest_route( |
| 172 |
$this->namespace, |
| 173 |
'/' . $this->rest_base . '/emails', |
| 174 |
array( |
| 175 |
array( |
| 176 |
'methods' => WP_REST_Server::READABLE, |
| 177 |
'callback' => array( $this, 'get_emails_settings' ), |
| 178 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 179 |
), |
| 180 |
) |
| 181 |
); |
| 182 |
register_rest_route( |
| 183 |
$this->namespace, |
| 184 |
'/' . $this->rest_base . '/emails/(?P<mail_type>[a-zA-Z0-9\-\.\_]+)/edit', |
| 185 |
array( |
| 186 |
array( |
| 187 |
'methods' => 'PUT, PATCH', |
| 188 |
'callback' => array( $this, 'update_emails_settings' ), |
| 189 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 190 |
'args' => $this->get_update_emails_allowed_fields(), |
| 191 |
), |
| 192 |
) |
| 193 |
); |
| 194 |
|
| 195 |
// Cost Tracker Settings. |
| 196 |
register_rest_route( |
| 197 |
$this->namespace, |
| 198 |
'/' . $this->rest_base . '/cost-tracker', |
| 199 |
array( |
| 200 |
array( |
| 201 |
'methods' => WP_REST_Server::READABLE, |
| 202 |
'callback' => array( $this, 'get_cost_tracker_settings' ), |
| 203 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 204 |
), |
| 205 |
) |
| 206 |
); |
| 207 |
register_rest_route( |
| 208 |
$this->namespace, |
| 209 |
'/' . $this->rest_base . '/cost-tracker/edit', |
| 210 |
array( |
| 211 |
array( |
| 212 |
'methods' => 'PUT, PATCH', |
| 213 |
'callback' => array( $this, 'edit_cost_tracker_settings' ), |
| 214 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 215 |
'args' => $this->get_cost_tracker_allowed_fields(), |
| 216 |
), |
| 217 |
) |
| 218 |
); |
| 219 |
register_rest_route( |
| 220 |
$this->namespace, |
| 221 |
'/' . $this->rest_base . '/cost-tracker/product-types/add', |
| 222 |
array( |
| 223 |
array( |
| 224 |
'methods' => WP_REST_Server::CREATABLE, |
| 225 |
'callback' => array( $this, 'add_cost_tracker_product_type' ), |
| 226 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 227 |
'args' => $this->get_add_cost_tracker_product_type_allowed_fields(), |
| 228 |
), |
| 229 |
) |
| 230 |
); |
| 231 |
register_rest_route( |
| 232 |
$this->namespace, |
| 233 |
'/' . $this->rest_base . '/cost-tracker/product-types/(?P<slug>[a-zA-Z0-9\-\.\_]+)/edit', |
| 234 |
array( |
| 235 |
array( |
| 236 |
'methods' => 'PUT, PATCH', |
| 237 |
'callback' => array( $this, 'update_cost_tracker_product_type' ), |
| 238 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 239 |
'args' => $this->get_edit_cost_tracker_product_type_allowed_fields(), |
| 240 |
), |
| 241 |
) |
| 242 |
); |
| 243 |
register_rest_route( |
| 244 |
$this->namespace, |
| 245 |
'/' . $this->rest_base . '/cost-tracker/product-types/(?P<slug>[a-zA-Z0-9\-\.\_]+)/delete', |
| 246 |
array( |
| 247 |
array( |
| 248 |
'methods' => WP_REST_Server::DELETABLE, |
| 249 |
'callback' => array( $this, 'delete_cost_tracker_product_type' ), |
| 250 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 251 |
'args' => $this->get_allowed_product_type_slug_field(), |
| 252 |
), |
| 253 |
) |
| 254 |
); |
| 255 |
register_rest_route( |
| 256 |
$this->namespace, |
| 257 |
'/' . $this->rest_base . '/cost-tracker/payment-methods/add', |
| 258 |
array( |
| 259 |
array( |
| 260 |
'methods' => WP_REST_Server::CREATABLE, |
| 261 |
'callback' => array( $this, 'add_cost_tracker_payment_method' ), |
| 262 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 263 |
'args' => $this->get_add_cost_tracker_payment_method_allowed_fields(), |
| 264 |
), |
| 265 |
) |
| 266 |
); |
| 267 |
register_rest_route( |
| 268 |
$this->namespace, |
| 269 |
'/' . $this->rest_base . '/cost-tracker/payment-methods/(?P<slug>[a-zA-Z0-9\-\.\_]+)/edit', |
| 270 |
array( |
| 271 |
array( |
| 272 |
'methods' => 'PUT, PATCH', |
| 273 |
'callback' => array( $this, 'update_cost_tracker_payment_method' ), |
| 274 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 275 |
'args' => $this->get_edit_cost_tracker_payment_method_allowed_fields(), |
| 276 |
), |
| 277 |
) |
| 278 |
); |
| 279 |
register_rest_route( |
| 280 |
$this->namespace, |
| 281 |
'/' . $this->rest_base . '/cost-tracker/payment-methods/(?P<slug>[a-zA-Z0-9\-\.\_]+)/delete', |
| 282 |
array( |
| 283 |
array( |
| 284 |
'methods' => WP_REST_Server::DELETABLE, |
| 285 |
'callback' => array( $this, 'delete_cost_tracker_payment_method' ), |
| 286 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 287 |
'args' => $this->get_allowed_payment_method_slug_field(), |
| 288 |
), |
| 289 |
) |
| 290 |
); |
| 291 |
|
| 292 |
// Dashboard Insights Settings. |
| 293 |
register_rest_route( |
| 294 |
$this->namespace, |
| 295 |
'/' . $this->rest_base . '/dashboard-insights', |
| 296 |
array( |
| 297 |
array( |
| 298 |
'methods' => WP_REST_Server::READABLE, |
| 299 |
'callback' => array( $this, 'get_dashboard_insights_settings' ), |
| 300 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 301 |
), |
| 302 |
) |
| 303 |
); |
| 304 |
register_rest_route( |
| 305 |
$this->namespace, |
| 306 |
'/' . $this->rest_base . '/dashboard-insights/edit', |
| 307 |
array( |
| 308 |
array( |
| 309 |
'methods' => 'PUT, PATCH', |
| 310 |
'callback' => array( $this, 'update_dashboard_insights_settings' ), |
| 311 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 312 |
'args' => $this->get_edit_dashboard_insight_allowed_fields(), |
| 313 |
), |
| 314 |
) |
| 315 |
); |
| 316 |
|
| 317 |
// Backup API Providers Settings. |
| 318 |
register_rest_route( |
| 319 |
$this->namespace, |
| 320 |
'/' . $this->rest_base . '/api-backups', |
| 321 |
array( |
| 322 |
array( |
| 323 |
'methods' => WP_REST_Server::READABLE, |
| 324 |
'callback' => array( $this, 'get_api_backup_settings' ), |
| 325 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 326 |
), |
| 327 |
) |
| 328 |
); |
| 329 |
register_rest_route( |
| 330 |
$this->namespace, |
| 331 |
'/' . $this->rest_base . '/api-backups/(?P<api_slug>[a-zA-Z0-9\-\.\_]+)/edit', |
| 332 |
array( |
| 333 |
array( |
| 334 |
'methods' => 'PUT, PATCH', |
| 335 |
'callback' => array( $this, 'update_api_backup_settings' ), |
| 336 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 337 |
'args' => $this->get_edit_api_backup_allowed_fields(), |
| 338 |
), |
| 339 |
) |
| 340 |
); |
| 341 |
|
| 342 |
// MainWP Dashboard Tools Settings. |
| 343 |
register_rest_route( |
| 344 |
$this->namespace, |
| 345 |
'/' . $this->rest_base . '/tools', |
| 346 |
array( |
| 347 |
array( |
| 348 |
'methods' => WP_REST_Server::READABLE, |
| 349 |
'callback' => array( $this, 'get_tool_settings' ), |
| 350 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 351 |
), |
| 352 |
) |
| 353 |
); |
| 354 |
register_rest_route( |
| 355 |
$this->namespace, |
| 356 |
'/' . $this->rest_base . '/tools/edit', |
| 357 |
array( |
| 358 |
array( |
| 359 |
'methods' => 'PUT, PATCH', |
| 360 |
'callback' => array( $this, 'update_tools_settings' ), |
| 361 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 362 |
'args' => $this->get_edit_tools_allowed_fields(), |
| 363 |
), |
| 364 |
) |
| 365 |
); |
| 366 |
register_rest_route( |
| 367 |
$this->namespace, |
| 368 |
'/' . $this->rest_base . '/tools/destroy-sessions', |
| 369 |
array( |
| 370 |
array( |
| 371 |
'methods' => WP_REST_Server::CREATABLE, |
| 372 |
'callback' => array( $this, 'destroy_sessions' ), |
| 373 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 374 |
), |
| 375 |
) |
| 376 |
); |
| 377 |
register_rest_route( |
| 378 |
$this->namespace, |
| 379 |
'/' . $this->rest_base . '/tools/destroy-sessions-status/(?P<destroy_id>[a-zA-Z0-9_.\-]+)', |
| 380 |
array( |
| 381 |
array( |
| 382 |
'methods' => WP_REST_Server::READABLE, |
| 383 |
'callback' => array( $this, 'get_destroy_sessions_status' ), |
| 384 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 385 |
'args' => array( |
| 386 |
'destroy_id' => array( |
| 387 |
'required' => true, |
| 388 |
'type' => 'string', |
| 389 |
), |
| 390 |
), |
| 391 |
), |
| 392 |
) |
| 393 |
); |
| 394 |
register_rest_route( |
| 395 |
$this->namespace, |
| 396 |
'/' . $this->rest_base . '/tools/renew-connections', |
| 397 |
array( |
| 398 |
array( |
| 399 |
'methods' => WP_REST_Server::CREATABLE, |
| 400 |
'callback' => array( $this, 'renew_connections' ), |
| 401 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 402 |
), |
| 403 |
) |
| 404 |
); |
| 405 |
register_rest_route( |
| 406 |
$this->namespace, |
| 407 |
'/' . $this->rest_base . '/tools/renew-connections-status/(?P<renew_id>[a-zA-Z0-9_.\-]+)', |
| 408 |
array( |
| 409 |
array( |
| 410 |
'methods' => WP_REST_Server::READABLE, |
| 411 |
'callback' => array( $this, 'get_renew_connection_status' ), |
| 412 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 413 |
'args' => array( |
| 414 |
'renew_id' => array( |
| 415 |
'required' => true, |
| 416 |
'type' => 'string', |
| 417 |
), |
| 418 |
), |
| 419 |
), |
| 420 |
) |
| 421 |
); |
| 422 |
register_rest_route( |
| 423 |
$this->namespace, |
| 424 |
'/' . $this->rest_base . '/tools/disconnect-all-sites', |
| 425 |
array( |
| 426 |
array( |
| 427 |
'methods' => WP_REST_Server::CREATABLE, |
| 428 |
'callback' => array( $this, 'disconnect_all_sites' ), |
| 429 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 430 |
), |
| 431 |
) |
| 432 |
); |
| 433 |
register_rest_route( |
| 434 |
$this->namespace, |
| 435 |
'/' . $this->rest_base . '/tools/disconnect-all-sites-status/(?P<disconnect_id>[a-zA-Z0-9_.\-]+)', |
| 436 |
array( |
| 437 |
array( |
| 438 |
'methods' => WP_REST_Server::READABLE, |
| 439 |
'callback' => array( $this, 'get_disconnect_status' ), |
| 440 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 441 |
'args' => array( |
| 442 |
'disconnect_id' => array( |
| 443 |
'required' => true, |
| 444 |
'type' => 'string', |
| 445 |
), |
| 446 |
), |
| 447 |
), |
| 448 |
) |
| 449 |
); |
| 450 |
register_rest_route( |
| 451 |
$this->namespace, |
| 452 |
'/' . $this->rest_base . '/tools/clear-activation-data', |
| 453 |
array( |
| 454 |
array( |
| 455 |
'methods' => WP_REST_Server::CREATABLE, |
| 456 |
'callback' => array( $this, 'clear_activation_data' ), |
| 457 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 458 |
), |
| 459 |
) |
| 460 |
); |
| 461 |
register_rest_route( |
| 462 |
$this->namespace, |
| 463 |
'/' . $this->rest_base . '/tools/restore-info-messages', |
| 464 |
array( |
| 465 |
array( |
| 466 |
'methods' => WP_REST_Server::CREATABLE, |
| 467 |
'callback' => array( $this, 'restore_info_messages' ), |
| 468 |
'permission_callback' => array( $this, 'get_rest_permissions_check' ), |
| 469 |
), |
| 470 |
) |
| 471 |
); |
| 472 |
} |
| 473 |
|
| 474 |
/** |
| 475 |
* Get all general settings. |
| 476 |
* |
| 477 |
* @param WP_REST_Request $request Full details about the request. |
| 478 |
* |
| 479 |
* @return WP_Error|WP_REST_Response |
| 480 |
*/ |
| 481 |
public function get_general_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 482 |
// Get general settings data. |
| 483 |
$settings = $this->get_general_settings_data(); |
| 484 |
|
| 485 |
// Response data by allowed fields. |
| 486 |
return rest_ensure_response( |
| 487 |
array( |
| 488 |
'success' => 1, |
| 489 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'view' ), |
| 490 |
) |
| 491 |
); |
| 492 |
} |
| 493 |
|
| 494 |
/** |
| 495 |
* Update general settings. |
| 496 |
* |
| 497 |
* @param WP_REST_Request $request Full details about the request. |
| 498 |
* |
| 499 |
* @uses MainWP_Utility::update_option() |
| 500 |
* |
| 501 |
* @return WP_Error|WP_REST_Response |
| 502 |
*/ |
| 503 |
public function update_general_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 504 |
|
| 505 |
// Check content type. |
| 506 |
$content_type = $this->validate_content_type( $request ); |
| 507 |
if ( is_wp_error( $content_type ) ) { |
| 508 |
return $content_type; |
| 509 |
} |
| 510 |
|
| 511 |
// Get request body. |
| 512 |
$body = $this->get_request_body( $request ); |
| 513 |
if ( is_wp_error( $body ) ) { |
| 514 |
return $body; |
| 515 |
} |
| 516 |
|
| 517 |
// Get current user id. |
| 518 |
$user_id = $this->get_user_id(); |
| 519 |
if ( is_wp_error( $user_id ) ) { |
| 520 |
return $user_id; |
| 521 |
} |
| 522 |
|
| 523 |
try { |
| 524 |
// Hepper function to update if present. |
| 525 |
$update_if_present = function ( $key, $option_name, $cast = null ) use ( $body ) { |
| 526 |
return $this->update_option_if_present( $body, $key, $option_name, $cast ); |
| 527 |
}; |
| 528 |
|
| 529 |
// Hepper function to update if present. |
| 530 |
$update_use_option = function ( $key, $option_name, $cast = null ) use ( $body, $user_id ) { |
| 531 |
if ( array_key_exists( $key, $body ) ) { |
| 532 |
$val = $body[ $key ]; |
| 533 |
$val = $this->cast_field_value( $val, $cast ); |
| 534 |
if ( 'mainwp_widgets' === $key ) { |
| 535 |
$show_widgets = get_user_option( 'mainwp_settings_show_widgets' ); |
| 536 |
$val = array_replace( $show_widgets, (array) $val ); |
| 537 |
} |
| 538 |
update_user_option( $user_id, $option_name, $val, true ); |
| 539 |
} |
| 540 |
}; |
| 541 |
|
| 542 |
// Update option setting. |
| 543 |
$update_if_present( 'time_daily_update', 'mainwp_timeDailyUpdate', 'string' ); |
| 544 |
$update_if_present( 'frequency_daily_update', 'mainwp_frequencyDailyUpdate', 'int' ); |
| 545 |
$update_if_present( 'date_format', 'date_format', 'string' ); |
| 546 |
$update_if_present( 'time_format', 'time_format', 'string' ); |
| 547 |
$update_if_present( 'timezone_string', 'gmt_offset', 'string' ); |
| 548 |
$update_if_present( 'hide_update_everything', 'mainwp_hide_update_everything', 'int' ); |
| 549 |
$update_if_present( 'plugin_automatic_daily_update', 'mainwp_pluginAutomaticDailyUpdate', 'int' ); |
| 550 |
$update_if_present( 'theme_automatic_daily_update', 'mainwp_themeAutomaticDailyUpdate', 'int' ); |
| 551 |
$update_if_present( 'trans_automatic_daily_update', 'mainwp_transAutomaticDailyUpdate', 'int' ); |
| 552 |
$update_if_present( 'automatic_daily_update', 'mainwp_automaticDailyUpdate', 'int' ); |
| 553 |
$update_if_present( 'frequency_auto_update', 'mainwp_frequency_AutoUpdate', 'string' ); |
| 554 |
$update_if_present( 'time_auto_update', 'mainwp_time_AutoUpdate', 'string' ); |
| 555 |
$update_if_present( 'show_language_updates', 'mainwp_show_language_updates', 'int' ); |
| 556 |
$update_if_present( 'disable_update_confirmations', 'mainwp_disable_update_confirmations', 'int' ); |
| 557 |
$update_if_present( 'check_http_response', 'mainwp_check_http_response', 'int' ); |
| 558 |
$update_if_present( 'check_http_response_method', 'mainwp_check_http_response_method', 'string' ); |
| 559 |
$update_if_present( 'backup_before_upgrade', 'mainwp_backup_before_upgrade', 'int' ); |
| 560 |
$update_if_present( 'backup_before_upgrade_days', 'mainwp_backup_before_upgrade_days', 'int' ); |
| 561 |
$update_if_present( 'numberdays_outdate_plugin_theme', 'mainwp_numberdays_Outdate_Plugin_Theme', 'int' ); |
| 562 |
$update_if_present( 'dayinweek_auto_update', 'mainwp_dayinweek_AutoUpdate', 'int' ); |
| 563 |
$update_if_present( 'dayinmonth_auto_update', 'mainwp_dayinmonth_AutoUpdate', 'int' ); |
| 564 |
$update_if_present( 'delay_autoupdate', 'mainwp_delay_autoupdate', 'int' ); |
| 565 |
|
| 566 |
// Update backup settings. |
| 567 |
$update_if_present( 'mainwp_primary_backup', 'mainwp_primaryBackup', 'string' ); |
| 568 |
$update_if_present( 'mainwp_enable_legacy_backup_feature', 'mainwp_enableLegacyBackupFeature', 'int' ); |
| 569 |
$update_if_present( 'mainwp_backups_on_server', 'mainwp_backupsOnServer', 'string' ); |
| 570 |
$update_if_present( 'mainwp_backup_on_external_sources', 'mainwp_backupOnExternalSources', 'string' ); |
| 571 |
$update_if_present( 'mainwp_archive_format', 'mainwp_archiveFormat', 'string' ); |
| 572 |
$update_if_present( 'mainwp_notification_on_backup_fail', 'mainwp_notificationOnBackupFail', 'int' ); |
| 573 |
$update_if_present( 'mainwp_notification_on_backup_start', 'mainwp_notificationOnBackupStart', 'int' ); |
| 574 |
$update_if_present( 'mainwp_chunked_backup_tasks', 'mainwp_chunkedBackupTasks', 'int' ); |
| 575 |
|
| 576 |
// Update Sidebar. |
| 577 |
$update_use_option( 'sidebar_position', 'mainwp_sidebarPosition', 'int' ); |
| 578 |
$update_use_option( 'mainwp_widgets', 'mainwp_settings_show_widgets', 'array' ); |
| 579 |
|
| 580 |
// Get general settings data. |
| 581 |
$settings = $this->get_general_settings_data(); |
| 582 |
} catch ( \Exception $e ) { |
| 583 |
do_action( 'mainwp_debug_log', 'Update general settings error: ' . $e->getMessage() ); |
| 584 |
return new WP_Error( |
| 585 |
'rest_invalid_param', |
| 586 |
/* translators: %s: Error message */ sprintf( __( 'Update general settings error: %s', 'mainwp' ), $e->getMessage() ), |
| 587 |
array( 'status' => 500 ) |
| 588 |
); |
| 589 |
} |
| 590 |
|
| 591 |
return rest_ensure_response( |
| 592 |
array( |
| 593 |
'success' => 1, |
| 594 |
'message' => esc_html__( 'General settings updated successfully.', 'mainwp' ), |
| 595 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'edit' ), |
| 596 |
) |
| 597 |
); |
| 598 |
} |
| 599 |
|
| 600 |
/** |
| 601 |
* Get all advanced settings. |
| 602 |
* |
| 603 |
* @param WP_REST_Request $request Full details about the request. |
| 604 |
* |
| 605 |
* @return WP_Error|WP_REST_Response |
| 606 |
*/ |
| 607 |
public function get_advanced_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 608 |
// Get advanced settings data. |
| 609 |
$settings = $this->get_advanced_settings_data(); |
| 610 |
|
| 611 |
return rest_ensure_response( |
| 612 |
array( |
| 613 |
'success' => 1, |
| 614 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'advanced_view', 'advanced_edit' ), |
| 615 |
) |
| 616 |
); |
| 617 |
} |
| 618 |
|
| 619 |
/** |
| 620 |
* Update advanced settings. |
| 621 |
* |
| 622 |
* @param WP_REST_Request $request Full details about the request. |
| 623 |
* |
| 624 |
* @uses MainWP_Utility::update_option() |
| 625 |
* @uses MainWP_System_Utility::get_open_ssl_sign_algos() |
| 626 |
* |
| 627 |
* @return WP_Error|WP_REST_Response |
| 628 |
*/ |
| 629 |
public function update_advanced_settings( $request ) { // phpcs:ignore -- NOSONAR - long method. |
| 630 |
// Check content type. |
| 631 |
$content_type = $this->validate_content_type( $request ); |
| 632 |
if ( is_wp_error( $content_type ) ) { |
| 633 |
return $content_type; |
| 634 |
} |
| 635 |
|
| 636 |
// Get request body. |
| 637 |
$body = $this->get_request_body( $request ); |
| 638 |
if ( is_wp_error( $body ) ) { |
| 639 |
return $body; |
| 640 |
} |
| 641 |
|
| 642 |
try { |
| 643 |
// Hepper function to update if present. |
| 644 |
$update_if_present = function ( $key, $option_name, $cast = null ) use ( $body ) { |
| 645 |
return $this->update_option_if_present( $body, $key, $option_name, $cast ); |
| 646 |
}; |
| 647 |
|
| 648 |
// Update option setting. |
| 649 |
$update_if_present( 'mainwp_maximum_requests', 'mainwp_maximumRequests', 'int' ); |
| 650 |
$update_if_present( 'mainwp_minimum_delay', 'mainwp_minimumDelay', 'int' ); |
| 651 |
$update_if_present( 'mainwp_maximum_ip_requests', 'mainwp_maximumIPRequests', 'int' ); |
| 652 |
$update_if_present( 'mainwp_minimum_ip_delay', 'mainwp_minimumIPDelay', 'int' ); |
| 653 |
$update_if_present( 'mainwp_chunksitesnumber', 'mainwp_chunksitesnumber', 'int' ); |
| 654 |
$update_if_present( 'mainwp_chunksleepinterval', 'mainwp_chunksleepinterval', 'int' ); |
| 655 |
$update_if_present( 'mainwp_maximum_sync_requests', 'mainwp_maximumSyncRequests', 'int' ); |
| 656 |
$update_if_present( 'mainwp_maximum_install_update_requests', 'mainwp_maximumInstallUpdateRequests', 'int' ); |
| 657 |
$update_if_present( 'mainwp_maximum_uptime_monitoring_requests', 'mainwp_maximum_uptime_monitoring_requests', 'int' ); |
| 658 |
$update_if_present( 'mainwp_optimize', 'mainwp_optimize', 'int' ); |
| 659 |
$update_if_present( 'mainwp_wp_cron', 'mainwp_wp_cron', 'int' ); |
| 660 |
$update_if_present( 'mainwp_ssl_verify_certificate', 'mainwp_sslVerifyCertificate', 'int' ); |
| 661 |
$update_if_present( 'mainwp_verify_connection_method', 'mainwp_verify_connection_method', 'int' ); |
| 662 |
$update_if_present( 'mainwp_force_use_ipv4', 'mainwp_forceUseIPv4', 'int' ); |
| 663 |
|
| 664 |
// Update sync data. |
| 665 |
if ( isset( $body['sync_data'] ) ) { |
| 666 |
$syncs_data = $this->safe_json_decode( get_option( 'mainwp_settings_sync_data', array() ) ?? '' ); |
| 667 |
$val_sync = array_replace( $syncs_data, (array) $body['sync_data'] ); |
| 668 |
MainWP_Utility::update_option( 'mainwp_settings_sync_data', wp_json_encode( $val_sync ) ); |
| 669 |
} |
| 670 |
|
| 671 |
// Update signature algorithm. |
| 672 |
if ( isset( $body['mainwp_connect_signature_algo'] ) ) { |
| 673 |
$sign_algs = MainWP_System_Utility::get_open_ssl_sign_algos(); |
| 674 |
$val_signature = array_search( $body['mainwp_connect_signature_algo'], $sign_algs, true ); |
| 675 |
if ( false === $val_signature ) { |
| 676 |
$val_signature = defined( 'OPENSSL_ALGO_SHA256' ) ? (int) OPENSSL_ALGO_SHA256 : 1; |
| 677 |
} |
| 678 |
|
| 679 |
MainWP_Utility::update_option( 'mainwp_connect_signature_algo', $val_signature ); |
| 680 |
} |
| 681 |
|
| 682 |
// Get general settings data. |
| 683 |
$settings = $this->get_advanced_settings_data(); |
| 684 |
} catch ( \Exception $e ) { |
| 685 |
do_action( 'mainwp_debug_log', 'Update advanced settings error: ' . $e->getMessage() ); |
| 686 |
return new WP_Error( |
| 687 |
'rest_invalid_param', |
| 688 |
/* translators: %s: Error message */ sprintf( __( 'Update advanced settings error: %s', 'mainwp' ), $e->getMessage() ), |
| 689 |
array( 'status' => 500 ) |
| 690 |
); |
| 691 |
} |
| 692 |
|
| 693 |
return rest_ensure_response( |
| 694 |
array( |
| 695 |
'success' => 1, |
| 696 |
'message' => esc_html__( 'General settings updated successfully.', 'mainwp' ), |
| 697 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'advanced_edit' ), |
| 698 |
) |
| 699 |
); |
| 700 |
} |
| 701 |
|
| 702 |
/** |
| 703 |
* Get all monitoring settings. |
| 704 |
* |
| 705 |
* @param WP_REST_Request $request Full details about the request. |
| 706 |
* |
| 707 |
* @return WP_Error|WP_REST_Response |
| 708 |
*/ |
| 709 |
public function get_monitoring_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 710 |
// Get monitoring settings data. |
| 711 |
$settings = $this->get_monitoring_settings_data(); |
| 712 |
|
| 713 |
return rest_ensure_response( |
| 714 |
array( |
| 715 |
'success' => 1, |
| 716 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'monitoring_view' ), |
| 717 |
) |
| 718 |
); |
| 719 |
} |
| 720 |
|
| 721 |
/** |
| 722 |
* Update monitoring settings. |
| 723 |
* |
| 724 |
* @param WP_REST_Request $request Full details about the request. |
| 725 |
* |
| 726 |
* @uses MainWP_Uptime_Monitoring_Handle::get_global_monitoring_settings() |
| 727 |
* @uses MainWP_Uptime_Monitoring_Handle::update_uptime_global_settings() |
| 728 |
* |
| 729 |
* @return WP_Error|WP_REST_Response |
| 730 |
*/ |
| 731 |
public function update_monitoring_settings( $request ) { // phpcs:ignore -- NOSONAR - long method. |
| 732 |
// Check content type. |
| 733 |
$content_type = $this->validate_content_type( $request ); |
| 734 |
if ( is_wp_error( $content_type ) ) { |
| 735 |
return $content_type; |
| 736 |
} |
| 737 |
|
| 738 |
// Get request body. |
| 739 |
$body = $this->get_request_body( $request ); |
| 740 |
if ( is_wp_error( $body ) ) { |
| 741 |
return $body; |
| 742 |
} |
| 743 |
|
| 744 |
// Get current settings. |
| 745 |
$current_settings = MainWP_Uptime_Monitoring_Handle::get_global_monitoring_settings(); |
| 746 |
$updated_settings = $current_settings; |
| 747 |
|
| 748 |
// Process setting. |
| 749 |
if ( isset( $body['mainwp_uptime_monitoring_active'] ) ) { |
| 750 |
$updated_settings['active'] = $body['mainwp_uptime_monitoring_active'] ? 1 : 0; |
| 751 |
} |
| 752 |
if ( isset( $body['mainwp_uptime_monitoring_down_confirmation_check'] ) ) { |
| 753 |
$updated_settings['maxretries'] = $body['mainwp_uptime_monitoring_down_confirmation_check']; |
| 754 |
} |
| 755 |
if ( isset( $body['mainwp_uptime_monitoring_up_status_codes'] ) ) { |
| 756 |
$updated_settings['up_status_codes'] = implode( ',', $body['mainwp_uptime_monitoring_up_status_codes'] ); |
| 757 |
} |
| 758 |
if ( isset( $body['mainwp_uptime_monitoring_interval'] ) ) { |
| 759 |
$interval_values = MainWP_Uptime_Monitoring_Edit::get_interval_values( false ); |
| 760 |
$interval = array_search( $body['mainwp_uptime_monitoring_interval'], $interval_values, true ); |
| 761 |
// An empty string passes the enum validator, so an unmatched label has to be rejected here, before anything is saved. |
| 762 |
if ( false === $interval ) { |
| 763 |
return new WP_Error( |
| 764 |
'rest_invalid_param', |
| 765 |
__( 'Invalid mainwp_uptime_monitoring_interval value.', 'mainwp' ), |
| 766 |
array( 'status' => 400 ) |
| 767 |
); |
| 768 |
} |
| 769 |
$updated_settings['interval'] = $interval; |
| 770 |
} |
| 771 |
if ( isset( $body['mainwp_uptime_monitoring_keyword'] ) ) { |
| 772 |
$updated_settings['keyword'] = $body['mainwp_uptime_monitoring_keyword']; |
| 773 |
} |
| 774 |
if ( isset( $body['mainwp_uptime_monitoring_method'] ) ) { |
| 775 |
$updated_settings['method'] = $body['mainwp_uptime_monitoring_method']; |
| 776 |
} |
| 777 |
if ( isset( $body['mainwp_uptime_monitoring_timeout'] ) ) { |
| 778 |
$timeout_values = MainWP_Uptime_Monitoring_Edit::get_timeout_values( false ); |
| 779 |
$timeout = array_search( $body['mainwp_uptime_monitoring_timeout'], $timeout_values, true ); |
| 780 |
// An empty string passes the enum validator, so an unmatched label has to be rejected here, before anything is saved. |
| 781 |
if ( false === $timeout ) { |
| 782 |
return new WP_Error( |
| 783 |
'rest_invalid_param', |
| 784 |
__( 'Invalid mainwp_uptime_monitoring_timeout value.', 'mainwp' ), |
| 785 |
array( 'status' => 400 ) |
| 786 |
); |
| 787 |
} |
| 788 |
$updated_settings['timeout'] = $timeout; |
| 789 |
} |
| 790 |
if ( isset( $body['mainwp_uptime_monitoring_type'] ) ) { |
| 791 |
$updated_settings['type'] = $body['mainwp_uptime_monitoring_type']; |
| 792 |
} |
| 793 |
|
| 794 |
if ( isset( $body['mainwp_uptime_monitoring_bypass_cache'] ) ) { |
| 795 |
$updated_settings['bypass_cache'] = $body['mainwp_uptime_monitoring_bypass_cache'] ? 1 : 0; |
| 796 |
} |
| 797 |
|
| 798 |
// Save monitoring the updated settings. |
| 799 |
$updated_settings = apply_filters( 'mainwp_uptime_monitoring_update_global_settings', $updated_settings ); |
| 800 |
MainWP_Uptime_Monitoring_Handle::update_uptime_global_settings( $updated_settings ); |
| 801 |
|
| 802 |
// Save Health Monitoring. |
| 803 |
if ( isset( $body['mainwp_disable_sites_health_monitoring'] ) ) { |
| 804 |
update_option( 'mainwp_disableSitesHealthMonitoring', (int) $body['mainwp_disable_sites_health_monitoring'] ); |
| 805 |
} |
| 806 |
if ( isset( $body['mainwp_sitehealth_threshold'] ) ) { |
| 807 |
update_option( 'mainwp_sitehealthThreshold', (int) $body['mainwp_sitehealth_threshold'] ); |
| 808 |
} |
| 809 |
|
| 810 |
return rest_ensure_response( |
| 811 |
array( |
| 812 |
'success' => 1, |
| 813 |
'data' => $this->filter_response_data_by_allowed_fields( $this->get_monitoring_settings_data(), 'monitoring_view' ), |
| 814 |
) |
| 815 |
); |
| 816 |
} |
| 817 |
|
| 818 |
/** |
| 819 |
* Get all email settings. |
| 820 |
* |
| 821 |
* @param WP_REST_Request $request Full details about the request. |
| 822 |
* |
| 823 |
* @uses MainWP_Notification_Settings::get_notification_types() |
| 824 |
* @uses MainWP_Notification_Settings::get_default_emails_fields() |
| 825 |
* |
| 826 |
* @return WP_Error|WP_REST_Response |
| 827 |
*/ |
| 828 |
public function get_emails_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 829 |
// Get notification email types. |
| 830 |
$notification_emails = MainWP_Notification_Settings::get_notification_types(); |
| 831 |
// Get email settings. |
| 832 |
$emails_settings = get_option( 'mainwp_settings_notification_emails' ); |
| 833 |
if ( ! is_array( $emails_settings ) ) { |
| 834 |
$emails_settings = array(); |
| 835 |
} |
| 836 |
|
| 837 |
$settings = array(); |
| 838 |
if ( ! empty( $notification_emails ) ) { |
| 839 |
foreach ( $notification_emails as $type => $name ) { |
| 840 |
$options = isset( $emails_settings[ $type ] ) ? $emails_settings[ $type ] : array(); |
| 841 |
$default = MainWP_Notification_Settings::get_default_emails_fields( $type, '', true ); |
| 842 |
$options = array_merge( $default, $options ); |
| 843 |
$record = array( |
| 844 |
'type' => $type, |
| 845 |
'heading' => $options['heading'], |
| 846 |
'subject' => $options['subject'], |
| 847 |
'recipients' => $options['recipients'], |
| 848 |
'disable' => $options['disable'], |
| 849 |
); |
| 850 |
$settings[] = $this->filter_response_data_by_allowed_fields( $record, 'email_view', 'email_edit' ); |
| 851 |
} |
| 852 |
} |
| 853 |
|
| 854 |
return rest_ensure_response( |
| 855 |
array( |
| 856 |
'success' => 1, |
| 857 |
'data' => $settings, |
| 858 |
) |
| 859 |
); |
| 860 |
} |
| 861 |
|
| 862 |
/** |
| 863 |
* Update email settings. |
| 864 |
* |
| 865 |
* @param WP_REST_Request $request Full details about the request. |
| 866 |
* |
| 867 |
* @uses MainWP_Utility::update_option() |
| 868 |
* |
| 869 |
* @return WP_Error|WP_REST_Response |
| 870 |
*/ |
| 871 |
public function update_emails_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 872 |
// Check content type. |
| 873 |
$content_type = $this->validate_content_type( $request ); |
| 874 |
if ( is_wp_error( $content_type ) ) { |
| 875 |
return $content_type; |
| 876 |
} |
| 877 |
|
| 878 |
// Get request body. |
| 879 |
$body = $this->get_request_body( $request ); |
| 880 |
if ( is_wp_error( $body ) ) { |
| 881 |
return $body; |
| 882 |
} |
| 883 |
|
| 884 |
// Get mail type. |
| 885 |
$setting = $request->get_param( 'mail_type' ); |
| 886 |
if ( empty( $setting ) ) { |
| 887 |
return new WP_Error( 'invalid_mail_type', __( 'Mail type is not exist.', 'mainwp' ), array( 'status' => 400 ) ); |
| 888 |
} |
| 889 |
|
| 890 |
$type = $setting['type'] ?? ''; |
| 891 |
if ( empty( $type ) ) { |
| 892 |
return new WP_Error( 'invalid_mail_type', __( 'Invalid email type.', 'mainwp' ), array( 'status' => 400 ) ); |
| 893 |
} |
| 894 |
|
| 895 |
// Get email settings. |
| 896 |
$emails_settings = get_option( 'mainwp_settings_notification_emails' ); |
| 897 |
if ( ! is_array( $emails_settings ) ) { |
| 898 |
$emails_settings = array(); |
| 899 |
} |
| 900 |
|
| 901 |
// Update email settings. |
| 902 |
$emails_settings[ $type ]['heading'] = ! empty( $body['heading'] ) ? $body['heading'] : $setting['heading']; |
| 903 |
$emails_settings[ $type ]['recipients'] = ! empty( $body['recipients'] ) ? $body['recipients'] : $setting['recipients']; |
| 904 |
$emails_settings[ $type ]['subject'] = ! empty( $body['subject'] ) ? $body['subject'] : $setting['subject']; |
| 905 |
$emails_settings[ $type ]['disable'] = ! empty( $body['disable'] ) ? $body['disable'] : $setting['disable']; |
| 906 |
MainWP_Utility::update_option( 'mainwp_settings_notification_emails', $emails_settings ); |
| 907 |
|
| 908 |
return rest_ensure_response( |
| 909 |
array( |
| 910 |
'success' => 1, |
| 911 |
'message' => __( 'Email settings updated successfully.', 'mainwp' ), |
| 912 |
'data' => $this->filter_response_data_by_allowed_fields( $emails_settings[ $type ], 'email_edit' ), |
| 913 |
) |
| 914 |
); |
| 915 |
} |
| 916 |
|
| 917 |
/** |
| 918 |
* Get all cost tracker settings. |
| 919 |
* |
| 920 |
* @param WP_REST_Request $request Full details about the request. |
| 921 |
* |
| 922 |
* @uses Cost_Tracker_Utility::get_instance()->get_option() |
| 923 |
* @uses Cost_Tracker_Utility::default_currency_settings() |
| 924 |
* @uses Cost_Tracker_Admin::get_product_types() |
| 925 |
* @uses Cost_Tracker_Admin::get_product_colors() |
| 926 |
* @uses Cost_Tracker_Admin::get_product_type_icons() |
| 927 |
* |
| 928 |
* @return WP_Error|WP_REST_Response |
| 929 |
*/ |
| 930 |
public function get_cost_tracker_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 931 |
// Get currency settings. |
| 932 |
$selected_currency = Cost_Tracker_Utility::get_instance()->get_option( 'currency', 'USD' ); |
| 933 |
$currency_format = Cost_Tracker_Utility::get_instance()->get_option( 'currency_format', array() ); |
| 934 |
|
| 935 |
// Get default currency format. |
| 936 |
$default = Cost_Tracker_Utility::default_currency_settings(); |
| 937 |
$currency_format = array_merge( $default, $currency_format ); |
| 938 |
|
| 939 |
$currency_position = $currency_format['currency_position']; |
| 940 |
$thousand_separator = $currency_format['thousand_separator']; |
| 941 |
$decimal_separator = $currency_format['decimal_separator']; |
| 942 |
$decimals = $currency_format['decimals']; |
| 943 |
|
| 944 |
// Get custom payment methods. |
| 945 |
$custom_payment_methods = Cost_Tracker_Utility::get_instance()->get_option( 'custom_payment_methods', array(), true ); |
| 946 |
|
| 947 |
// Get custom product types. |
| 948 |
$custom_product_types = Cost_Tracker_Admin::get_product_types(); |
| 949 |
|
| 950 |
// Get product colors. |
| 951 |
$product_colors = Cost_Tracker_Admin::get_product_colors(); |
| 952 |
|
| 953 |
// Get product icons. |
| 954 |
$product_types_icons = Cost_Tracker_Admin::get_product_type_icons(); |
| 955 |
|
| 956 |
$product_categories = array(); |
| 957 |
if ( ! empty( $product_types_icons ) && is_array( $product_types_icons ) ) { |
| 958 |
foreach ( $product_types_icons as $slug => $icon ) { |
| 959 |
$product_categories[] = array( |
| 960 |
'slug' => $slug, |
| 961 |
'title' => isset( $custom_product_types[ $slug ] ) ? $custom_product_types[ $slug ] : '', |
| 962 |
'icon' => $icon, |
| 963 |
'color' => isset( $product_colors[ $slug ] ) ? $product_colors[ $slug ] : '#34424D', |
| 964 |
); |
| 965 |
} |
| 966 |
} |
| 967 |
|
| 968 |
$settings = array( |
| 969 |
'currency' => $selected_currency, |
| 970 |
'currency_position' => $currency_position, |
| 971 |
'thousand_separator' => $thousand_separator, |
| 972 |
'decimal_separator' => $decimal_separator, |
| 973 |
'decimals' => $decimals, |
| 974 |
'product_categories' => $product_categories, |
| 975 |
'payment_methods' => $custom_payment_methods, |
| 976 |
); |
| 977 |
|
| 978 |
return rest_ensure_response( |
| 979 |
array( |
| 980 |
'success' => 1, |
| 981 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'cost_tracker_view' ), |
| 982 |
) |
| 983 |
); |
| 984 |
} |
| 985 |
|
| 986 |
/** |
| 987 |
* Edit cost tracker settings. |
| 988 |
* |
| 989 |
* @param WP_REST_Request $request Full details about the request. |
| 990 |
* |
| 991 |
* @uses Cost_Tracker_Utility::get_instance()->get_all_options() |
| 992 |
* @uses Cost_Tracker_Utility::get_instance()->save_options() |
| 993 |
* |
| 994 |
* @return WP_Error|WP_REST_Response |
| 995 |
*/ |
| 996 |
public function edit_cost_tracker_settings( $request ) { |
| 997 |
// Check content type. |
| 998 |
$content_type = $this->validate_content_type( $request ); |
| 999 |
if ( is_wp_error( $content_type ) ) { |
| 1000 |
return $content_type; |
| 1001 |
} |
| 1002 |
|
| 1003 |
// Get request body. |
| 1004 |
$body = $this->get_request_body( $request ); |
| 1005 |
if ( is_wp_error( $body ) ) { |
| 1006 |
return $body; |
| 1007 |
} |
| 1008 |
|
| 1009 |
// Get all options. |
| 1010 |
$all_opts = Cost_Tracker_Utility::get_instance()->get_all_options(); |
| 1011 |
$currency_format = $all_opts['currency_format'] ?? array(); // Set old currency format setting. |
| 1012 |
|
| 1013 |
// Map body to variables. |
| 1014 |
$all_opts['currency'] = ! empty( $body['currency'] ) ? $body['currency'] : $all_opts['currency']; |
| 1015 |
$all_opts['currency_format'] = array( |
| 1016 |
'currency_position' => ! empty( $body['currency_position'] ) ? $body['currency_position'] : $currency_format['currency_position'], |
| 1017 |
'thousand_separator' => ! empty( $body['thousand_separator'] ) ? $body['thousand_separator'] : $currency_format['thousand_separator'], |
| 1018 |
'decimal_separator' => ! empty( $body['decimal_separator'] ) ? $body['decimal_separator'] : $currency_format['decimal_separator'], |
| 1019 |
'decimals' => ! empty( $body['decimals'] ) ? $body['decimals'] : $currency_format['decimals'], |
| 1020 |
); |
| 1021 |
|
| 1022 |
// Save options. |
| 1023 |
Cost_Tracker_Utility::get_instance()->save_options( $all_opts ); |
| 1024 |
|
| 1025 |
return rest_ensure_response( |
| 1026 |
array( |
| 1027 |
'success' => 1, |
| 1028 |
'message' => __( 'Cost tracker settings updated successfully.', 'mainwp' ), |
| 1029 |
'data' => array( |
| 1030 |
'currency' => $all_opts['currency'], |
| 1031 |
'currency_format' => $all_opts['currency_format'], |
| 1032 |
), |
| 1033 |
) |
| 1034 |
); |
| 1035 |
} |
| 1036 |
|
| 1037 |
/** |
| 1038 |
* Add cost tracker product type. |
| 1039 |
* |
| 1040 |
* @param WP_REST_Request $request Full details about the request. |
| 1041 |
* |
| 1042 |
* @uses Cost_Tracker_Utility::get_instance()->get_all_options() |
| 1043 |
* @uses Cost_Tracker_Utility::get_instance()->save_options() |
| 1044 |
* |
| 1045 |
* @return WP_Error|WP_REST_Response |
| 1046 |
*/ |
| 1047 |
public function add_cost_tracker_product_type( $request ) { // phpcs:ignore -- NOSONAR - long method. |
| 1048 |
$body = $this->get_request_body( $request ); |
| 1049 |
|
| 1050 |
if ( is_wp_error( $body ) ) { |
| 1051 |
return $body; |
| 1052 |
} |
| 1053 |
|
| 1054 |
// Map body to variables. |
| 1055 |
$title = $body['title']; |
| 1056 |
$slug = sanitize_title( $title ); |
| 1057 |
$color = ! empty( $body['color'] ) ? $body['color'] : '#34424D'; |
| 1058 |
$icon = ! empty( $body['icon'] ) ? $body['icon'] : 'deficon:folder open'; |
| 1059 |
|
| 1060 |
// Map product type. |
| 1061 |
$all_opts = Cost_Tracker_Utility::get_instance()->get_all_options(); |
| 1062 |
$custom_product_types = $this->safe_json_decode( $all_opts['custom_product_types'] ?? '' ); |
| 1063 |
|
| 1064 |
// Check if product type duplicated. |
| 1065 |
if ( isset( $custom_product_types[ $slug ] ) ) { |
| 1066 |
return new WP_Error( 'duplicate_title', __( 'Duplicate product type. Please choose another one.', 'mainwp' ), array( 'status' => 400 ) ); |
| 1067 |
} |
| 1068 |
// Map product type. |
| 1069 |
$custom_product_types[ $slug ] = $title; |
| 1070 |
$all_opts['custom_product_types'] = wp_json_encode( $custom_product_types ); |
| 1071 |
|
| 1072 |
// Map product type color. |
| 1073 |
$product_types_colors = $this->safe_json_decode( $all_opts['product_types_colors'] ?? '' ); |
| 1074 |
$product_types_colors[ $slug ] = $color; |
| 1075 |
$all_opts['product_types_colors'] = wp_json_encode( $product_types_colors ); |
| 1076 |
|
| 1077 |
// Map product type icon. |
| 1078 |
$product_types_icons = $this->safe_json_decode( $all_opts['product_types_icons'] ?? '' ); |
| 1079 |
$product_types_icons[ $slug ] = $icon; |
| 1080 |
$all_opts['product_types_icons'] = wp_json_encode( $product_types_icons ); |
| 1081 |
|
| 1082 |
// Save options. |
| 1083 |
Cost_Tracker_Utility::get_instance()->save_options( $all_opts ); |
| 1084 |
return rest_ensure_response( |
| 1085 |
array( |
| 1086 |
'success' => 1, |
| 1087 |
'message' => __( 'Product type added successfully.', 'mainwp' ), |
| 1088 |
'data' => array( |
| 1089 |
$slug => array( |
| 1090 |
'title' => $title, |
| 1091 |
'color' => $color, |
| 1092 |
'icon' => $icon, |
| 1093 |
), |
| 1094 |
), |
| 1095 |
) |
| 1096 |
); |
| 1097 |
} |
| 1098 |
|
| 1099 |
/** |
| 1100 |
* Update cost tracker product type. |
| 1101 |
* |
| 1102 |
* @param WP_REST_Request $request Full details about the request. |
| 1103 |
* |
| 1104 |
* @uses Cost_Tracker_Utility::get_instance()->get_all_options() |
| 1105 |
* @uses Cost_Tracker_Utility::get_instance()->save_options() |
| 1106 |
* |
| 1107 |
* @return WP_Error|WP_REST_Response |
| 1108 |
*/ |
| 1109 |
public function update_cost_tracker_product_type( $request ) { // phpcs:ignore -- NOSONAR - long method. |
| 1110 |
// Check content type. |
| 1111 |
$content_type = $this->validate_content_type( $request ); |
| 1112 |
if ( is_wp_error( $content_type ) ) { |
| 1113 |
return $content_type; |
| 1114 |
} |
| 1115 |
|
| 1116 |
// Get request body. |
| 1117 |
$body = $this->get_request_body( $request ); |
| 1118 |
if ( is_wp_error( $body ) ) { |
| 1119 |
return $body; |
| 1120 |
} |
| 1121 |
|
| 1122 |
$slug = $request->get_param( 'slug' ); |
| 1123 |
if ( empty( $slug ) ) { |
| 1124 |
return new WP_Error( 'invalid_slug', __( 'Invalid product type slug.', 'mainwp' ), array( 'status' => 400 ) ); |
| 1125 |
} |
| 1126 |
|
| 1127 |
// Default Product Type. |
| 1128 |
$default_product_types = Cost_Tracker_Admin::get_default_product_types(); |
| 1129 |
|
| 1130 |
// Map body to variables. |
| 1131 |
$title = $body['title']; |
| 1132 |
$color = ! empty( $body['color'] ) ? $body['color'] : '#34424D'; |
| 1133 |
$icon = ! empty( $body['icon'] ) ? $body['icon'] : 'deficon:folder open'; |
| 1134 |
|
| 1135 |
// Cannot change title if it's a default product type. |
| 1136 |
if ( array_key_exists( $slug, $default_product_types ) && $title !== $default_product_types[ $slug ] ) { |
| 1137 |
return new WP_Error( 'invalid_title', __( 'Cannot change title of default product type.', 'mainwp' ), array( 'status' => 400 ) ); |
| 1138 |
} |
| 1139 |
|
| 1140 |
// Map product type. |
| 1141 |
$all_opts = Cost_Tracker_Utility::get_instance()->get_all_options(); |
| 1142 |
$custom_product_types = $this->safe_json_decode( $all_opts['custom_product_types'] ?? '' ); |
| 1143 |
$custom_product_types[ $slug ] = $title; |
| 1144 |
$all_opts['custom_product_types'] = wp_json_encode( $custom_product_types ); |
| 1145 |
|
| 1146 |
// Map product type color. |
| 1147 |
$product_types_colors = $this->safe_json_decode( $all_opts['product_types_colors'] ?? '' ); |
| 1148 |
$product_types_colors[ $slug ] = $color; |
| 1149 |
$all_opts['product_types_colors'] = wp_json_encode( $product_types_colors ); |
| 1150 |
|
| 1151 |
// Map product type icon. |
| 1152 |
$product_types_icons = $this->safe_json_decode( $all_opts['product_types_icons'] ?? '' ); |
| 1153 |
$product_types_icons[ $slug ] = $icon; |
| 1154 |
$all_opts['product_types_icons'] = wp_json_encode( $product_types_icons ); |
| 1155 |
|
| 1156 |
// Save options. |
| 1157 |
Cost_Tracker_Utility::get_instance()->save_options( $all_opts ); |
| 1158 |
return rest_ensure_response( |
| 1159 |
array( |
| 1160 |
'success' => 1, |
| 1161 |
'message' => __( 'Product type updated successfully.', 'mainwp' ), |
| 1162 |
'data' => array( |
| 1163 |
$slug => array( |
| 1164 |
'title' => $title, |
| 1165 |
'color' => $color, |
| 1166 |
'icon' => $icon, |
| 1167 |
), |
| 1168 |
), |
| 1169 |
) |
| 1170 |
); |
| 1171 |
} |
| 1172 |
|
| 1173 |
/** |
| 1174 |
* Delete cost tracker product type. |
| 1175 |
* |
| 1176 |
* @param WP_REST_Request $request Full details about the request. |
| 1177 |
* |
| 1178 |
* @uses Cost_Tracker_Utility::get_instance()->get_all_options() |
| 1179 |
* @uses Cost_Tracker_Utility::get_instance()->save_options() |
| 1180 |
* |
| 1181 |
* @return WP_Error|WP_REST_Response |
| 1182 |
*/ |
| 1183 |
public function delete_cost_tracker_product_type( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1184 |
$slug = $request->get_param( 'slug' ); |
| 1185 |
|
| 1186 |
if ( empty( $slug ) ) { |
| 1187 |
return new WP_Error( 'invalid_slug', __( 'Invalid product type slug.', 'mainwp' ), array( 'status' => 400 ) ); |
| 1188 |
} |
| 1189 |
|
| 1190 |
// Default Product Type. |
| 1191 |
$default_product_types = Cost_Tracker_Admin::get_default_product_types(); |
| 1192 |
// Cannot delete a default product type. |
| 1193 |
if ( array_key_exists( $slug, $default_product_types ) ) { |
| 1194 |
return new WP_Error( 'invalid_title', __( 'Cannot delete of default product type.', 'mainwp' ), array( 'status' => 400 ) ); |
| 1195 |
} |
| 1196 |
|
| 1197 |
// Get all options. |
| 1198 |
$all_opts = Cost_Tracker_Utility::get_instance()->get_all_options(); |
| 1199 |
$custom_product_types = $this->safe_json_decode( $all_opts['custom_product_types'] ?? '' ); |
| 1200 |
$product_types_colors = $this->safe_json_decode( $all_opts['product_types_colors'] ?? '' ); |
| 1201 |
$product_types_icons = $this->safe_json_decode( $all_opts['product_types_icons'] ?? '' ); |
| 1202 |
|
| 1203 |
// Check if product type exists. |
| 1204 |
if ( ! isset( $custom_product_types[ $slug ] ) ) { |
| 1205 |
return new WP_Error( 'invalid_slug', __( 'Product type does not exist.', 'mainwp' ), array( 'status' => 404 ) ); |
| 1206 |
} |
| 1207 |
|
| 1208 |
// Delete product type. |
| 1209 |
unset( $custom_product_types[ $slug ] ); |
| 1210 |
unset( $product_types_colors[ $slug ] ); |
| 1211 |
unset( $product_types_icons[ $slug ] ); |
| 1212 |
|
| 1213 |
$all_opts['custom_product_types'] = wp_json_encode( $custom_product_types ); |
| 1214 |
$all_opts['product_types_colors'] = wp_json_encode( $product_types_colors ); |
| 1215 |
$all_opts['product_types_icons'] = wp_json_encode( $product_types_icons ); |
| 1216 |
|
| 1217 |
// Save options. |
| 1218 |
Cost_Tracker_Utility::get_instance()->save_options( $all_opts ); |
| 1219 |
|
| 1220 |
return rest_ensure_response( |
| 1221 |
array( |
| 1222 |
'success' => 1, |
| 1223 |
'message' => __( 'Product type deleted successfully.', 'mainwp' ), |
| 1224 |
) |
| 1225 |
); |
| 1226 |
} |
| 1227 |
|
| 1228 |
/** |
| 1229 |
* Add cost tracker payment method. |
| 1230 |
* |
| 1231 |
* @param WP_REST_Request $request Full details about the request. |
| 1232 |
* |
| 1233 |
* @uses Cost_Tracker_Utility::get_instance()->get_option() |
| 1234 |
* @uses Cost_Tracker_Utility::get_instance()->update_option() |
| 1235 |
* |
| 1236 |
* @return WP_Error|WP_REST_Response |
| 1237 |
*/ |
| 1238 |
public function add_cost_tracker_payment_method( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1239 |
// Get request body. |
| 1240 |
$body = $this->get_request_body( $request ); |
| 1241 |
if ( is_wp_error( $body ) ) { |
| 1242 |
return $body; |
| 1243 |
} |
| 1244 |
|
| 1245 |
$title = $body['title']; |
| 1246 |
$slug = sanitize_title( $title ); |
| 1247 |
|
| 1248 |
// Get all options. |
| 1249 |
$all_opts = Cost_Tracker_Utility::get_instance()->get_all_options(); |
| 1250 |
|
| 1251 |
// Get payment methods. |
| 1252 |
$payment_methods = $this->safe_json_decode( $all_opts['custom_payment_methods'] ?? '' ); |
| 1253 |
|
| 1254 |
if ( isset( $payment_methods[ $slug ] ) ) { |
| 1255 |
return new WP_Error( 'duplicate_title', __( 'Duplicate payment method. Please choose another one.', 'mainwp' ), array( 'status' => 400 ) ); |
| 1256 |
} |
| 1257 |
|
| 1258 |
// Save payment method. |
| 1259 |
$payment_methods[ $slug ] = $title; |
| 1260 |
$all_opts['custom_payment_methods'] = wp_json_encode( $payment_methods ); |
| 1261 |
|
| 1262 |
// Save options. |
| 1263 |
Cost_Tracker_Utility::get_instance()->save_options( $all_opts ); |
| 1264 |
|
| 1265 |
return rest_ensure_response( |
| 1266 |
array( |
| 1267 |
'success' => 1, |
| 1268 |
'message' => __( 'Payment method added successfully.', 'mainwp' ), |
| 1269 |
'data' => array( |
| 1270 |
$slug => $title, |
| 1271 |
), |
| 1272 |
) |
| 1273 |
); |
| 1274 |
} |
| 1275 |
|
| 1276 |
/** |
| 1277 |
* Edit cost tracker payment method. |
| 1278 |
* |
| 1279 |
* @param WP_REST_Request $request Full details about the request. |
| 1280 |
* |
| 1281 |
* @uses Cost_Tracker_Utility::get_instance()->get_all_options() |
| 1282 |
* @uses Cost_Tracker_Utility::get_instance()->update_option() |
| 1283 |
* |
| 1284 |
* @return WP_Error|WP_REST_Response |
| 1285 |
*/ |
| 1286 |
public function update_cost_tracker_payment_method( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1287 |
// Check content type. |
| 1288 |
$content_type = $this->validate_content_type( $request ); |
| 1289 |
if ( is_wp_error( $content_type ) ) { |
| 1290 |
return $content_type; |
| 1291 |
} |
| 1292 |
|
| 1293 |
// Get request body. |
| 1294 |
$body = $this->get_request_body( $request ); |
| 1295 |
if ( is_wp_error( $body ) ) { |
| 1296 |
return $body; |
| 1297 |
} |
| 1298 |
|
| 1299 |
$slug = $request->get_param( 'slug' ); |
| 1300 |
|
| 1301 |
// Get all options. |
| 1302 |
$all_opts = Cost_Tracker_Utility::get_instance()->get_all_options(); |
| 1303 |
// Get payment methods. |
| 1304 |
$payment_methods = $this->safe_json_decode( $all_opts['custom_payment_methods'] ?? '' ); |
| 1305 |
if ( ! isset( $payment_methods[ $slug ] ) ) { |
| 1306 |
return new WP_Error( 'invalid_slug', __( 'Invalid payment method slug.', 'mainwp' ), array( 'status' => 404 ) ); |
| 1307 |
} |
| 1308 |
|
| 1309 |
$payment_methods[ $slug ] = $body['title']; |
| 1310 |
$all_opts['custom_payment_methods'] = wp_json_encode( $payment_methods ); |
| 1311 |
Cost_Tracker_Utility::get_instance()->save_options( $all_opts ); |
| 1312 |
|
| 1313 |
return rest_ensure_response( |
| 1314 |
array( |
| 1315 |
'success' => 1, |
| 1316 |
'message' => __( 'Payment method updated successfully.', 'mainwp' ), |
| 1317 |
'data' => array( |
| 1318 |
$slug => $body['title'], |
| 1319 |
), |
| 1320 |
) |
| 1321 |
); |
| 1322 |
} |
| 1323 |
|
| 1324 |
/** |
| 1325 |
* Delete cost tracker payment method. |
| 1326 |
* |
| 1327 |
* @param WP_REST_Request $request Full details about the request. |
| 1328 |
* |
| 1329 |
* @uses Cost_Tracker_Utility::get_instance()->get_all_options() |
| 1330 |
* @uses Cost_Tracker_Utility::get_instance()->update_option() |
| 1331 |
* |
| 1332 |
* @return WP_Error|WP_REST_Response |
| 1333 |
*/ |
| 1334 |
public function delete_cost_tracker_payment_method( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1335 |
$slug = $request->get_param( 'slug' ); |
| 1336 |
|
| 1337 |
// Get all options. |
| 1338 |
$all_opts = Cost_Tracker_Utility::get_instance()->get_all_options(); |
| 1339 |
// Get payment methods. |
| 1340 |
$payment_methods = $this->safe_json_decode( $all_opts['custom_payment_methods'] ?? '' ); |
| 1341 |
if ( ! isset( $payment_methods[ $slug ] ) ) { |
| 1342 |
return new WP_Error( 'invalid_slug', __( 'Invalid payment method slug.', 'mainwp' ), array( 'status' => 404 ) ); |
| 1343 |
} |
| 1344 |
|
| 1345 |
unset( $payment_methods[ $slug ] ); |
| 1346 |
$all_opts['custom_payment_methods'] = wp_json_encode( $payment_methods ); |
| 1347 |
Cost_Tracker_Utility::get_instance()->save_options( $all_opts ); |
| 1348 |
|
| 1349 |
return rest_ensure_response( |
| 1350 |
array( |
| 1351 |
'success' => 1, |
| 1352 |
'message' => __( 'Payment method deleted successfully.', 'mainwp' ), |
| 1353 |
) |
| 1354 |
); |
| 1355 |
} |
| 1356 |
|
| 1357 |
/** |
| 1358 |
* Get all dashboard insights settings. |
| 1359 |
* |
| 1360 |
* @param WP_REST_Request $request Full details about the request. |
| 1361 |
* |
| 1362 |
* @return WP_Error|WP_REST_Response |
| 1363 |
*/ |
| 1364 |
public function get_dashboard_insights_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1365 |
$options = get_option( 'mainwp_module_log_settings', array() ); |
| 1366 |
$settings = array( |
| 1367 |
'enable_insights_logging' => $options['enabled'] ?? 0, |
| 1368 |
); |
| 1369 |
|
| 1370 |
return rest_ensure_response( |
| 1371 |
array( |
| 1372 |
'success' => 1, |
| 1373 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'dashboard_insights_view' ), |
| 1374 |
) |
| 1375 |
); |
| 1376 |
} |
| 1377 |
|
| 1378 |
/** |
| 1379 |
* Update dashboard insights settings. |
| 1380 |
* |
| 1381 |
* @param WP_REST_Request $request Full details about the request. |
| 1382 |
* |
| 1383 |
* @return WP_Error|WP_REST_Response |
| 1384 |
*/ |
| 1385 |
public function update_dashboard_insights_settings( $request ) { |
| 1386 |
// Check content type. |
| 1387 |
$content_type = $this->validate_content_type( $request ); |
| 1388 |
if ( is_wp_error( $content_type ) ) { |
| 1389 |
return $content_type; |
| 1390 |
} |
| 1391 |
|
| 1392 |
// Get request body. |
| 1393 |
$body = $this->get_request_body( $request ); |
| 1394 |
if ( is_wp_error( $body ) ) { |
| 1395 |
return $body; |
| 1396 |
} |
| 1397 |
|
| 1398 |
// Get Current settings. |
| 1399 |
$current_insights_logging = get_option( 'mainwp_module_log_settings', 1 ); |
| 1400 |
$new_insights_logging = $current_insights_logging; |
| 1401 |
if ( isset( $body['enable_insights_logging'] ) ) { |
| 1402 |
$new_insights_logging['enabled'] = $body['enable_insights_logging']; |
| 1403 |
} |
| 1404 |
|
| 1405 |
// Save settings. |
| 1406 |
MainWP_Utility::update_option( 'mainwp_module_log_settings', $new_insights_logging ); |
| 1407 |
|
| 1408 |
return rest_ensure_response( |
| 1409 |
array( |
| 1410 |
'success' => 1, |
| 1411 |
'message' => __( 'Dashboard insights settings updated successfully.', 'mainwp' ), |
| 1412 |
'data' => array( |
| 1413 |
'enable_insights_logging' => $new_insights_logging['enabled'], |
| 1414 |
), |
| 1415 |
) |
| 1416 |
); |
| 1417 |
} |
| 1418 |
|
| 1419 |
/** |
| 1420 |
* Get all API backup settings. |
| 1421 |
* |
| 1422 |
* @param WP_REST_Request $request Full details about the request. |
| 1423 |
* |
| 1424 |
* @return WP_Error|WP_REST_Response |
| 1425 |
*/ |
| 1426 |
public function get_api_backup_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1427 |
// Masked token. |
| 1428 |
$masked = static function ( $token ) { |
| 1429 |
$token = (string) $token; |
| 1430 |
if ( empty( $token ) ) { |
| 1431 |
return ''; |
| 1432 |
} |
| 1433 |
return '****' . substr( $token, -4 ); |
| 1434 |
}; |
| 1435 |
|
| 1436 |
// Get all API backup settings. |
| 1437 |
$defs = $this->get_api_backup_definitions(); |
| 1438 |
$api_backups_data = array(); |
| 1439 |
|
| 1440 |
foreach ( $defs as $slug => $def ) { |
| 1441 |
$provider = array( |
| 1442 |
'label' => $def['label'], |
| 1443 |
'enabled' => (int) get_option( $def['enabled_option'], 0 ), |
| 1444 |
); |
| 1445 |
|
| 1446 |
if ( ! empty( $def['options'] ) ) { |
| 1447 |
foreach ( $def['options'] as $field => $option_key ) { |
| 1448 |
$provider[ $field ] = get_option( $option_key, '' ); |
| 1449 |
} |
| 1450 |
} |
| 1451 |
|
| 1452 |
// Get secrets key. |
| 1453 |
$secrets = array(); |
| 1454 |
if ( ! empty( $def['secrets'] ) ) { |
| 1455 |
foreach ( $def['secrets'] as $secret_key => $getter ) { |
| 1456 |
$value = is_callable( $getter ) ? call_user_func( $getter ) : ''; |
| 1457 |
$secrets[ $secret_key ] = $masked( $value ); |
| 1458 |
} |
| 1459 |
} |
| 1460 |
$provider['secrets'] = $secrets; |
| 1461 |
|
| 1462 |
// Add provider to API backups data. |
| 1463 |
$api_backups_data[ $slug ] = $provider; |
| 1464 |
} |
| 1465 |
|
| 1466 |
return rest_ensure_response( |
| 1467 |
array( |
| 1468 |
'success' => 1, |
| 1469 |
'data' => $this->filter_response_data_by_allowed_fields( array( 'api_backups' => $api_backups_data ), 'api_backups_view' ), |
| 1470 |
) |
| 1471 |
); |
| 1472 |
} |
| 1473 |
|
| 1474 |
/** |
| 1475 |
* Update API backup settings. |
| 1476 |
* |
| 1477 |
* @param WP_REST_Request $request Full details about the request. |
| 1478 |
* |
| 1479 |
* @uses MainWP_Utility::update_option() |
| 1480 |
* @uses Api_Backups_Utility::get_instance()->update_api_key() |
| 1481 |
* |
| 1482 |
* @return WP_Error|WP_REST_Response |
| 1483 |
*/ |
| 1484 |
public function update_api_backup_settings( $request ) { |
| 1485 |
// Check content type. |
| 1486 |
$content_type = $this->validate_content_type( $request ); |
| 1487 |
if ( is_wp_error( $content_type ) ) { |
| 1488 |
return $content_type; |
| 1489 |
} |
| 1490 |
|
| 1491 |
// Get request body. |
| 1492 |
$body = $this->get_request_body( $request ); |
| 1493 |
if ( is_wp_error( $body ) ) { |
| 1494 |
return $body; |
| 1495 |
} |
| 1496 |
|
| 1497 |
// Get API slug data. |
| 1498 |
$api = $request->get_param( 'api_slug' ); |
| 1499 |
if ( empty( $api ) ) { |
| 1500 |
return new WP_Error( 'invalid_api_slug', __( 'API backup not exists.', 'mainwp' ), array( 'status' => 400 ) ); |
| 1501 |
} |
| 1502 |
|
| 1503 |
$updated = array(); |
| 1504 |
// Update option if present. |
| 1505 |
$update_if_present = function ( $key, $option_name ) use ( $body, &$updated ) { |
| 1506 |
// Check if key is set and option name is not empty. |
| 1507 |
if ( isset( $body[ $key ] ) && ! empty( $option_name ) ) { |
| 1508 |
MainWP_Utility::update_option( $option_name, $body[ $key ] ); |
| 1509 |
$updated[ $key ] = $body[ $key ]; |
| 1510 |
} |
| 1511 |
}; |
| 1512 |
|
| 1513 |
// Update secrets if present. |
| 1514 |
$update_secrets_api = function ( $slug, $value, $name = 'api_key' ) use ( &$updated ) { // phpcs:ignore -- NOSONAR - complex. |
| 1515 |
$success = Api_Backups_Utility::get_instance()->update_api_key( $slug, $value ); |
| 1516 |
if ( $success ) { |
| 1517 |
$updated[ $name ] = $value; |
| 1518 |
} |
| 1519 |
}; |
| 1520 |
|
| 1521 |
// Update api option. |
| 1522 |
$update_if_present( 'enabled', $api['enabled_option'] ?? '' ); |
| 1523 |
$update_if_present( 'account_email', $api['options']['account_email'] ?? '' ); |
| 1524 |
$update_if_present( 'url', $api['options']['url'] ?? '' ); |
| 1525 |
$update_if_present( 'site_path', $api['options']['site_path'] ?? '' ); |
| 1526 |
$update_if_present( 'username', $api['options']['username'] ?? '' ); |
| 1527 |
$update_if_present( 'company_id', $api['options']['company_id'] ?? '' ); |
| 1528 |
|
| 1529 |
// Update api key or password. |
| 1530 |
if ( ! empty( $api['slug'] ) ) { |
| 1531 |
if ( isset( $body['secrets']['api_key'] ) ) { |
| 1532 |
$update_secrets_api( $api['slug'] ?? '', $body['secrets']['api_key'] ?? '', 'api_key' ); |
| 1533 |
} |
| 1534 |
if ( isset( $body['password'] ) ) { |
| 1535 |
$update_secrets_api( $api['slug'] ?? '', $body['password'] ?? '', 'password' ); |
| 1536 |
} |
| 1537 |
} |
| 1538 |
|
| 1539 |
if ( ! empty( $api['slug'] ) && 'cloudways' === $api['slug'] && isset( $body['secrets']['access_token'] ) ) { |
| 1540 |
$success = Api_Backups_Utility::get_instance()->update_api_key( 'cloudways', $body['secrets']['access_token'], 'access_token' ); |
| 1541 |
if ( $success ) { |
| 1542 |
$updated['access_token'] = $body['secrets']['access_token']; |
| 1543 |
} |
| 1544 |
} |
| 1545 |
|
| 1546 |
// Get secrets key. |
| 1547 |
$secrets = array( 'api_key', 'access_token', 'password' ); |
| 1548 |
foreach ( $secrets as $secret_key ) { |
| 1549 |
if ( isset( $updated[ $secret_key ] ) ) { |
| 1550 |
$updated[ $secret_key ] = MainWP_Credential_Render::value_for_input( false ); |
| 1551 |
} |
| 1552 |
} |
| 1553 |
|
| 1554 |
return rest_ensure_response( |
| 1555 |
array( |
| 1556 |
'success' => 1, |
| 1557 |
'message' => __( 'API backup settings updated successfully.', 'mainwp' ), |
| 1558 |
'data' => $updated, |
| 1559 |
) |
| 1560 |
); |
| 1561 |
} |
| 1562 |
|
| 1563 |
/** |
| 1564 |
* Get all tool settings. |
| 1565 |
* |
| 1566 |
* @param WP_REST_Request $request Full details about the request. |
| 1567 |
* |
| 1568 |
* @return WP_Error|WP_REST_Response |
| 1569 |
*/ |
| 1570 |
public function get_tool_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1571 |
// Get tool settings. |
| 1572 |
$settings = $this->get_tool_settings_data(); |
| 1573 |
|
| 1574 |
return rest_ensure_response( |
| 1575 |
array( |
| 1576 |
'success' => 1, |
| 1577 |
'data' => $this->filter_response_data_by_allowed_fields( $settings, 'tool_view' ), |
| 1578 |
) |
| 1579 |
); |
| 1580 |
} |
| 1581 |
|
| 1582 |
/** |
| 1583 |
* Update tool settings. |
| 1584 |
* |
| 1585 |
* @param WP_REST_Request $request Full details about the request. |
| 1586 |
* |
| 1587 |
* @return WP_Error|WP_REST_Response |
| 1588 |
*/ |
| 1589 |
public function update_tools_settings( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1590 |
// Check content type. |
| 1591 |
$content_type = $this->validate_content_type( $request ); |
| 1592 |
if ( is_wp_error( $content_type ) ) { |
| 1593 |
return $content_type; |
| 1594 |
} |
| 1595 |
|
| 1596 |
// Get request body. |
| 1597 |
$body = $this->get_request_body( $request ); |
| 1598 |
if ( is_wp_error( $body ) ) { |
| 1599 |
return $body; |
| 1600 |
} |
| 1601 |
|
| 1602 |
$user_id = $this->get_user_id(); |
| 1603 |
if ( is_wp_error( $user_id ) ) { |
| 1604 |
return $user_id; |
| 1605 |
} |
| 1606 |
|
| 1607 |
// update theme option. |
| 1608 |
if ( isset( $body['mainwp_theme'] ) && ! empty( $body['mainwp_theme'] ) ) { |
| 1609 |
update_user_option( $user_id, 'mainwp_selected_theme', $body['mainwp_theme'] ); |
| 1610 |
} |
| 1611 |
|
| 1612 |
// Update option. |
| 1613 |
$this->update_option_if_present( $body, 'mainwp_theme', 'mainwp_selected_theme', 'string' ); |
| 1614 |
$this->update_option_if_present( $body, 'guided_tours', 'mainwp_enable_guided_tours', 'bool' ); |
| 1615 |
$this->update_option_if_present( $body, 'chatbase', 'mainwp_enable_guided_chatbase', 'bool' ); |
| 1616 |
$this->update_option_if_present( $body, 'guided_video', 'mainwp_enable_guided_video', 'bool' ); |
| 1617 |
|
| 1618 |
return rest_ensure_response( |
| 1619 |
array( |
| 1620 |
'success' => 1, |
| 1621 |
'message' => __( 'Tools settings updated successfully.', 'mainwp' ), |
| 1622 |
'data' => $this->filter_response_data_by_allowed_fields( $this->get_tool_settings_data(), 'tool_view' ), |
| 1623 |
) |
| 1624 |
); |
| 1625 |
} |
| 1626 |
|
| 1627 |
/** |
| 1628 |
* Destroy sessions. |
| 1629 |
* |
| 1630 |
* @param WP_REST_Request $request Full details about the request. |
| 1631 |
* |
| 1632 |
* @return WP_Error|WP_REST_Response |
| 1633 |
*/ |
| 1634 |
public function destroy_sessions( $request ) { |
| 1635 |
$websites = $this->get_websites(); |
| 1636 |
if ( is_wp_error( $websites ) ) { |
| 1637 |
return $websites; |
| 1638 |
} |
| 1639 |
|
| 1640 |
$destroy_id = uniqid( 'destroy_', true ); |
| 1641 |
$websites = array_column( $websites, 'id' ); |
| 1642 |
set_transient( |
| 1643 |
"mainwp_tool_destroy_job_{$destroy_id}", |
| 1644 |
array( |
| 1645 |
'status' => 'pending', |
| 1646 |
'total' => count( $websites ), |
| 1647 |
'processed' => 0, |
| 1648 |
'failed' => 0, |
| 1649 |
'created_at' => time(), |
| 1650 |
'websites' => $websites, |
| 1651 |
), |
| 1652 |
DAY_IN_SECONDS |
| 1653 |
); |
| 1654 |
|
| 1655 |
// Schedule background task. |
| 1656 |
if ( function_exists( 'as_schedule_single_action' ) ) { |
| 1657 |
as_schedule_single_action( |
| 1658 |
time(), |
| 1659 |
'mainwp_cron_destroy_session_batch', |
| 1660 |
array( $destroy_id ) |
| 1661 |
); |
| 1662 |
} else { |
| 1663 |
wp_schedule_single_event( time(), 'mainwp_cron_destroy_session_batch', array( $destroy_id ) ); |
| 1664 |
spawn_cron(); // Run cron now. |
| 1665 |
} |
| 1666 |
|
| 1667 |
// Return status url. |
| 1668 |
$status_url = $this->namespace . '/' . $this->rest_base . '/tools/destroy-sessions-status/' . $destroy_id; |
| 1669 |
return rest_ensure_response( |
| 1670 |
array( |
| 1671 |
'success' => 1, |
| 1672 |
'message' => __( 'Destroy sessions process started in background.', 'mainwp' ), |
| 1673 |
'destroy_id' => $destroy_id, |
| 1674 |
'status_url' => rest_url( $status_url ), |
| 1675 |
) |
| 1676 |
); |
| 1677 |
} |
| 1678 |
|
| 1679 |
/** |
| 1680 |
* Get destroy sessions status. |
| 1681 |
* |
| 1682 |
* @param WP_REST_Request $request Full details about the request. |
| 1683 |
* |
| 1684 |
* @return WP_Error|WP_REST_Response |
| 1685 |
*/ |
| 1686 |
public function get_destroy_sessions_status( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 1687 |
|
| 1688 |
$destroy_id = $request->get_param( 'destroy_id' ); // Get id from url. |
| 1689 |
if ( empty( $destroy_id ) ) { |
| 1690 |
return new WP_Error( |
| 1691 |
'missing_destroy_id', |
| 1692 |
__( 'Destroy ID is required.', 'mainwp' ), |
| 1693 |
array( 'status' => 400 ) |
| 1694 |
); |
| 1695 |
} |
| 1696 |
|
| 1697 |
$destroy_data = get_transient( "mainwp_tool_destroy_job_{$destroy_id}" ); |
| 1698 |
if ( ! $destroy_data ) { |
| 1699 |
return new WP_Error( |
| 1700 |
'destroy_session_job_not_found', |
| 1701 |
__( 'Destroy session job not found.', 'mainwp' ), |
| 1702 |
array( 'status' => 404 ) |
| 1703 |
); |
| 1704 |
} |
| 1705 |
|
| 1706 |
return rest_ensure_response( |
| 1707 |
array( |
| 1708 |
'success' => 'completed' === $destroy_data['status'] && 0 === $destroy_data['failed'], |
| 1709 |
'status' => $destroy_data['status'], |
| 1710 |
'total' => $destroy_data['total'], |
| 1711 |
'processed' => $destroy_data['processed'], |
| 1712 |
'failed' => $destroy_data['failed'], |
| 1713 |
'progress' => round( ( $destroy_data['processed'] / $destroy_data['total'] ) * 100, 2 ), |
| 1714 |
'errors' => ! empty( $destroy_data['errors'] ) ? array_slice( $destroy_data['errors'], 0, 10 ) : array(), |
| 1715 |
'started_at' => $destroy_data['started_at'] ?? '', |
| 1716 |
'completed_at' => $destroy_data['completed_at'] ?? '', |
| 1717 |
) |
| 1718 |
); |
| 1719 |
} |
| 1720 |
|
| 1721 |
/** |
| 1722 |
* Process destroy session batch. |
| 1723 |
* |
| 1724 |
* @param string $destroy_id Destroy ID. |
| 1725 |
* |
| 1726 |
* @uses MainWP_System_Utility::can_edit_website() |
| 1727 |
* |
| 1728 |
* @return void |
| 1729 |
*/ |
| 1730 |
public function process_destroy_session_batch( $destroy_id ) { // phpcs:ignore -- NOSONAR - complex. |
| 1731 |
$destroy_data = get_transient( "mainwp_tool_destroy_job_{$destroy_id}" ); |
| 1732 |
if ( ! $destroy_data || 'completed' === $destroy_data['status'] ) { |
| 1733 |
return; |
| 1734 |
} |
| 1735 |
$website_ids = $destroy_data['websites']; |
| 1736 |
$start_index = $destroy_data['processed']; |
| 1737 |
$batch = array_slice( $website_ids, $start_index, $this->batch_size ); |
| 1738 |
|
| 1739 |
foreach ( $batch as $website_id ) { |
| 1740 |
try { |
| 1741 |
$website = $this->get_website_by_id( $website_id, $destroy_data ); |
| 1742 |
if ( empty( $website ) ) { |
| 1743 |
continue; |
| 1744 |
} |
| 1745 |
|
| 1746 |
if ( MainWP_System_Utility::can_edit_website( $website ) ) { |
| 1747 |
++$destroy_data['processed']; |
| 1748 |
} else { |
| 1749 |
++$destroy_data['failed']; |
| 1750 |
++$destroy_data['processed']; |
| 1751 |
$destroy_data['errors'][] = array( |
| 1752 |
'site_id' => $website_id, |
| 1753 |
'error' => __( 'You cannot edit this website.', 'mainwp' ), |
| 1754 |
); |
| 1755 |
} |
| 1756 |
} catch ( \Exception $e ) { |
| 1757 |
++$destroy_data['failed']; |
| 1758 |
++$destroy_data['processed']; |
| 1759 |
$destroy_data['errors'][] = array( |
| 1760 |
'site_id' => $website_id, |
| 1761 |
'error' => $e->getMessage(), |
| 1762 |
); |
| 1763 |
} |
| 1764 |
} |
| 1765 |
|
| 1766 |
// Reschedule or completed. |
| 1767 |
if ( $destroy_data['processed'] >= $destroy_data['total'] ) { |
| 1768 |
$destroy_data['status'] = 'completed'; |
| 1769 |
$destroy_data['completed_at'] = time(); |
| 1770 |
delete_transient( "mainwp_tool_destroy_job_{$destroy_id}" ); // Delete transient when completed. |
| 1771 |
} elseif ( function_exists( 'as_schedule_single_action' ) ) { |
| 1772 |
as_schedule_single_action( |
| 1773 |
time() + 3, |
| 1774 |
'mainwp_cron_destroy_session_batch', |
| 1775 |
array( $destroy_id ) |
| 1776 |
); |
| 1777 |
} else { |
| 1778 |
wp_schedule_single_event( time() + 3, 'mainwp_cron_destroy_session_batch', array( $destroy_id ) ); |
| 1779 |
spawn_cron(); // Run Cron now. |
| 1780 |
} |
| 1781 |
|
| 1782 |
// Update transient. |
| 1783 |
set_transient( "mainwp_tool_destroy_job_{$destroy_id}", $destroy_data, DAY_IN_SECONDS ); |
| 1784 |
} |
| 1785 |
|
| 1786 |
/** |
| 1787 |
* Renew connections. |
| 1788 |
* |
| 1789 |
* @param WP_REST_Request $request Full details about the request. |
| 1790 |
* |
| 1791 |
* @return WP_Error|WP_REST_Response |
| 1792 |
*/ |
| 1793 |
public function renew_connections( $request ) { |
| 1794 |
$websites = $this->get_websites(); |
| 1795 |
if ( is_wp_error( $websites ) ) { |
| 1796 |
return $websites; |
| 1797 |
} |
| 1798 |
|
| 1799 |
$renew_id = uniqid( 'renew_', true ); |
| 1800 |
$websites = array_column( $websites, 'id' ); |
| 1801 |
set_transient( |
| 1802 |
"mainwp_tool_renew_job_{$renew_id}", |
| 1803 |
array( |
| 1804 |
'status' => 'pending', |
| 1805 |
'total' => count( $websites ), |
| 1806 |
'processed' => 0, |
| 1807 |
'failed' => 0, |
| 1808 |
'created_at' => time(), |
| 1809 |
'websites' => $websites, |
| 1810 |
), |
| 1811 |
DAY_IN_SECONDS |
| 1812 |
); |
| 1813 |
|
| 1814 |
// Schedule background task. |
| 1815 |
if ( function_exists( 'as_schedule_single_action' ) ) { |
| 1816 |
as_schedule_single_action( |
| 1817 |
time(), |
| 1818 |
'mainwp_cron_renew_connection_batch', |
| 1819 |
array( $renew_id ) |
| 1820 |
); |
| 1821 |
} else { |
| 1822 |
wp_schedule_single_event( time(), 'mainwp_cron_renew_connection_batch', array( $renew_id ) ); |
| 1823 |
spawn_cron(); // Run cron now. |
| 1824 |
} |
| 1825 |
|
| 1826 |
// Return status url. |
| 1827 |
$status_url = $this->namespace . '/' . $this->rest_base . '/tools/renew-connections-status/' . $renew_id; |
| 1828 |
return rest_ensure_response( |
| 1829 |
array( |
| 1830 |
'success' => 1, |
| 1831 |
'message' => __( 'Renew connection process started in background.', 'mainwp' ), |
| 1832 |
'renew_id' => $renew_id, |
| 1833 |
'status_url' => rest_url( $status_url ), |
| 1834 |
) |
| 1835 |
); |
| 1836 |
} |
| 1837 |
|
| 1838 |
/** |
| 1839 |
* Get renew connection status. |
| 1840 |
* |
| 1841 |
* @param WP_REST_Request $request Full details about the request. |
| 1842 |
* |
| 1843 |
* @return WP_Error|WP_REST_Response |
| 1844 |
*/ |
| 1845 |
public function get_renew_connection_status( $request ) { |
| 1846 |
$renew_id = $request->get_param( 'renew_id' ); // Get id from url. |
| 1847 |
|
| 1848 |
if ( empty( $renew_id ) ) { |
| 1849 |
return new WP_Error( |
| 1850 |
'missing_renew_id', |
| 1851 |
__( 'Renew ID is required.', 'mainwp' ), |
| 1852 |
array( 'status' => 400 ) |
| 1853 |
); |
| 1854 |
} |
| 1855 |
|
| 1856 |
// Get disconnect data. |
| 1857 |
$renew_data = get_transient( "mainwp_tool_renew_job_{$renew_id}" ); |
| 1858 |
|
| 1859 |
if ( ! $renew_data ) { |
| 1860 |
return new WP_Error( |
| 1861 |
'renew_connection_job_not_found', |
| 1862 |
__( 'Renew connection job not found.', 'mainwp' ), |
| 1863 |
array( 'status' => 404 ) |
| 1864 |
); |
| 1865 |
} |
| 1866 |
|
| 1867 |
return rest_ensure_response( |
| 1868 |
array( |
| 1869 |
'success' => 'completed' === $renew_data['status'] && 0 === $renew_data['failed'], |
| 1870 |
'status' => $renew_data['status'], |
| 1871 |
'total' => $renew_data['total'], |
| 1872 |
'processed' => $renew_data['processed'], |
| 1873 |
'failed' => $renew_data['failed'], |
| 1874 |
'progress' => round( ( $renew_data['processed'] / $renew_data['total'] ) * 100, 2 ), |
| 1875 |
'errors' => ! empty( $renew_data['errors'] ) ? array_slice( $renew_data['errors'], 0, 10 ) : array(), |
| 1876 |
'started_at' => $renew_data['started_at'] ?? '', |
| 1877 |
'completed_at' => $renew_data['completed_at'] ?? '', |
| 1878 |
) |
| 1879 |
); |
| 1880 |
} |
| 1881 |
|
| 1882 |
/** |
| 1883 |
* Process renew connection batch. |
| 1884 |
* |
| 1885 |
* @param string $renew_id Renew ID. |
| 1886 |
* |
| 1887 |
* @uses MainWP_Sync::sync_site() |
| 1888 |
* @uses MainWP_Connect::fetch_url_authed() |
| 1889 |
* @uses MainWP_Manage_Sites_View::m_reconnect_site() |
| 1890 |
* @uses MainWP_Logger::instance()->info_for_website() |
| 1891 |
*/ |
| 1892 |
public function process_renew_connection_batch( $renew_id ) { // phpcs:ignore -- NOSONAR - complex. |
| 1893 |
$renew_data = get_transient( "mainwp_tool_renew_job_{$renew_id}" ); |
| 1894 |
if ( ! $renew_data || 'completed' === $renew_data['status'] ) { |
| 1895 |
return; |
| 1896 |
} |
| 1897 |
$website_ids = $renew_data['websites']; |
| 1898 |
$start_index = $renew_data['processed']; |
| 1899 |
$batch = array_slice( $website_ids, $start_index, $this->batch_size ); |
| 1900 |
|
| 1901 |
foreach ( $batch as $website_id ) { |
| 1902 |
try { |
| 1903 |
$website = $this->get_website_by_id( $website_id, $renew_data ); |
| 1904 |
if ( empty( $website ) ) { |
| 1905 |
continue; |
| 1906 |
} |
| 1907 |
|
| 1908 |
if ( '' !== $website->sync_errors ) { |
| 1909 |
// try reconnect, if failed. |
| 1910 |
MainWP_Sync::sync_site( $website, true ); |
| 1911 |
} |
| 1912 |
|
| 1913 |
$result = MainWP_Connect::fetch_url_authed( $website, 'renew' ); |
| 1914 |
if ( is_array( $result ) && isset( $result['result'] ) && 'success' === $result['result'] ) { |
| 1915 |
// reconnect immediately, to renew. |
| 1916 |
if ( MainWP_Manage_Sites_View::m_reconnect_site( $website, false ) ) { |
| 1917 |
MainWP_Logger::instance()->info_for_website( $website, 'renew', 'Renew connection successfully.' ); |
| 1918 |
++$renew_data['processed']; |
| 1919 |
} else { |
| 1920 |
++$renew_data['failed']; |
| 1921 |
++$renew_data['processed']; |
| 1922 |
$renew_data['errors'][] = array( |
| 1923 |
'site_id' => $website_id, |
| 1924 |
'error' => $result['error'] ?? __( 'Try to reconnect site failed', 'mainwp' ), |
| 1925 |
); |
| 1926 |
} |
| 1927 |
} else { |
| 1928 |
++$renew_data['failed']; |
| 1929 |
++$renew_data['processed']; |
| 1930 |
$renew_data['errors'][] = array( |
| 1931 |
'site_id' => $website_id, |
| 1932 |
'error' => $result['error'] ?? __( 'Try to disconnect site failed', 'mainwp' ), |
| 1933 |
); |
| 1934 |
MainWP_Logger::instance()->info_for_website( $website, 'renew', 'Try to disconnect site failed.' ); |
| 1935 |
} |
| 1936 |
} catch ( \Exception $e ) { |
| 1937 |
++$renew_data['failed']; |
| 1938 |
++$renew_data['processed']; |
| 1939 |
$renew_data['errors'][] = array( |
| 1940 |
'site_id' => $website_id, |
| 1941 |
'error' => $e->getMessage(), |
| 1942 |
); |
| 1943 |
} |
| 1944 |
} |
| 1945 |
|
| 1946 |
// Reschedule or completed. |
| 1947 |
if ( $renew_data['processed'] >= $renew_data['total'] ) { |
| 1948 |
$renew_data['status'] = 'completed'; |
| 1949 |
$renew_data['completed_at'] = time(); |
| 1950 |
delete_transient( "mainwp_tool_renew_job_{$renew_id}" ); // Delete transient when completed. |
| 1951 |
} elseif ( function_exists( 'as_schedule_single_action' ) ) { |
| 1952 |
as_schedule_single_action( |
| 1953 |
time() + 3, |
| 1954 |
'mainwp_cron_renew_connection_batch', |
| 1955 |
array( $renew_id ) |
| 1956 |
); |
| 1957 |
} else { |
| 1958 |
wp_schedule_single_event( time() + 3, 'mainwp_cron_renew_connection_batch', array( $renew_id ) ); |
| 1959 |
spawn_cron(); // Run Cron now. |
| 1960 |
} |
| 1961 |
|
| 1962 |
// Update transient. |
| 1963 |
set_transient( "mainwp_tool_renew_job_{$renew_id}", $renew_data, DAY_IN_SECONDS ); |
| 1964 |
} |
| 1965 |
|
| 1966 |
/** |
| 1967 |
* Disconnect all sites. |
| 1968 |
* |
| 1969 |
* @param WP_REST_Request $request Full details about the request. |
| 1970 |
* |
| 1971 |
* @return WP_Error|WP_REST_Response |
| 1972 |
*/ |
| 1973 |
public function disconnect_all_sites( $request ) { |
| 1974 |
$websites = $this->get_websites(); |
| 1975 |
if ( is_wp_error( $websites ) ) { |
| 1976 |
return $websites; |
| 1977 |
} |
| 1978 |
|
| 1979 |
$disconnect_id = uniqid( 'disconnect_', true ); |
| 1980 |
set_transient( |
| 1981 |
"mainwp_tool_disconnect_job_{$disconnect_id}", |
| 1982 |
array( |
| 1983 |
'status' => 'pending', |
| 1984 |
'total' => count( $websites ), |
| 1985 |
'processed' => 0, |
| 1986 |
'failed' => 0, |
| 1987 |
'created_at' => time(), |
| 1988 |
'websites' => array_column( $websites, 'id' ), |
| 1989 |
), |
| 1990 |
DAY_IN_SECONDS |
| 1991 |
); |
| 1992 |
|
| 1993 |
// Schedule background task. |
| 1994 |
if ( function_exists( 'as_schedule_single_action' ) ) { |
| 1995 |
as_schedule_single_action( |
| 1996 |
time(), |
| 1997 |
'mainwp_cron_disconnect_batch', |
| 1998 |
array( $disconnect_id ) |
| 1999 |
); |
| 2000 |
} else { |
| 2001 |
wp_schedule_single_event( time(), 'mainwp_cron_disconnect_batch', array( $disconnect_id ) ); |
| 2002 |
spawn_cron(); // Run cron now. |
| 2003 |
} |
| 2004 |
|
| 2005 |
// Return status url. |
| 2006 |
$status_url = $this->namespace . '/' . $this->rest_base . '/tools/disconnect-status/' . $disconnect_id; |
| 2007 |
return rest_ensure_response( |
| 2008 |
array( |
| 2009 |
'success' => 1, |
| 2010 |
'message' => __( 'Disconnect process started in background.', 'mainwp' ), |
| 2011 |
'disconnect_id' => $disconnect_id, |
| 2012 |
'status_url' => rest_url( $status_url ), |
| 2013 |
) |
| 2014 |
); |
| 2015 |
} |
| 2016 |
|
| 2017 |
/** |
| 2018 |
* Process disconnect batch. |
| 2019 |
* |
| 2020 |
* @param string $disconnect_id Disconnect ID. |
| 2021 |
* |
| 2022 |
* @uses MainWP_Connect::fetch_url_authed() |
| 2023 |
* |
| 2024 |
* @return void |
| 2025 |
*/ |
| 2026 |
public function process_disconnect_batch( $disconnect_id ) { // phpcs:ignore -- NOSONAR |
| 2027 |
$disconnect_data = get_transient( "mainwp_tool_disconnect_job_{$disconnect_id}" ); |
| 2028 |
if ( ! $disconnect_data || 'completed' === $disconnect_data['status'] ) { |
| 2029 |
return; |
| 2030 |
} |
| 2031 |
|
| 2032 |
// Check if websites are available. |
| 2033 |
if ( empty( $disconnect_data['websites'] ) || ! is_array( $disconnect_data['websites'] ) ) { |
| 2034 |
return; |
| 2035 |
} |
| 2036 |
|
| 2037 |
$website_ids = $disconnect_data['websites']; |
| 2038 |
$start_index = $disconnect_data['processed']; |
| 2039 |
$batch = array_slice( $website_ids, $start_index, $this->batch_size ); |
| 2040 |
|
| 2041 |
foreach ( $batch as $website_id ) { |
| 2042 |
try { |
| 2043 |
$website = $this->get_website_by_id( $website_id, $disconnect_data ); |
| 2044 |
if ( empty( $website ) ) { |
| 2045 |
continue; |
| 2046 |
} |
| 2047 |
|
| 2048 |
$result = MainWP_Connect::fetch_url_authed( $website, 'disconnect' ); |
| 2049 |
if ( is_array( $result ) && isset( $result['result'] ) && 'success' === $result['result'] ) { |
| 2050 |
++$disconnect_data['processed']; |
| 2051 |
} else { |
| 2052 |
++$disconnect_data['failed']; |
| 2053 |
++$disconnect_data['processed']; |
| 2054 |
$disconnect_data['errors'][] = array( |
| 2055 |
'site_id' => $website_id, |
| 2056 |
'error' => $result['error'] ?? __( 'Unknown error', 'mainwp' ), |
| 2057 |
); |
| 2058 |
} |
| 2059 |
} catch ( \Exception $e ) { |
| 2060 |
++$disconnect_data['failed']; |
| 2061 |
++$disconnect_data['processed']; |
| 2062 |
$disconnect_data['errors'][] = array( |
| 2063 |
'site_id' => $website_id, |
| 2064 |
'error' => $e->getMessage(), |
| 2065 |
); |
| 2066 |
} |
| 2067 |
} |
| 2068 |
|
| 2069 |
if ( $disconnect_data['processed'] >= $disconnect_data['total'] ) { |
| 2070 |
$disconnect_data['status'] = 'completed'; |
| 2071 |
$disconnect_data['completed_at'] = time(); |
| 2072 |
delete_transient( "mainwp_tool_disconnect_job_{$disconnect_id}" ); // Delete transient when completed. |
| 2073 |
} elseif ( function_exists( 'as_schedule_single_action' ) ) { |
| 2074 |
as_schedule_single_action( |
| 2075 |
time() + 3, |
| 2076 |
'mainwp_cron_disconnect_batch', |
| 2077 |
array( $disconnect_id ) |
| 2078 |
); |
| 2079 |
} else { |
| 2080 |
wp_schedule_single_event( time() + 3, 'mainwp_disconnect_site_batch', array( $disconnect_id ) ); |
| 2081 |
spawn_cron(); // Run Cron now. |
| 2082 |
} |
| 2083 |
|
| 2084 |
set_transient( "mainwp_tool_disconnect_job_{$disconnect_id}", $disconnect_data, DAY_IN_SECONDS ); |
| 2085 |
} |
| 2086 |
|
| 2087 |
/** |
| 2088 |
* Get disconnect job status. |
| 2089 |
* |
| 2090 |
* @param WP_REST_Request $request REST request. |
| 2091 |
* |
| 2092 |
* @return WP_REST_Response|WP_Error Response or error. |
| 2093 |
*/ |
| 2094 |
public function get_disconnect_status( $request ) { |
| 2095 |
$disconnect_id = $request->get_param( 'disconnect_id' ); // Get id from url. |
| 2096 |
|
| 2097 |
if ( empty( $disconnect_id ) ) { |
| 2098 |
return new WP_Error( |
| 2099 |
'missing_disconnect_id', |
| 2100 |
__( 'Disconnect ID is required.', 'mainwp' ), |
| 2101 |
array( 'status' => 400 ) |
| 2102 |
); |
| 2103 |
} |
| 2104 |
|
| 2105 |
// Get disconnect data. |
| 2106 |
$disconnect_data = get_transient( "mainwp_tool_disconnect_job_{$disconnect_id}" ); |
| 2107 |
|
| 2108 |
if ( ! $disconnect_data ) { |
| 2109 |
return new WP_Error( |
| 2110 |
'disconnect_job_not_found', |
| 2111 |
__( 'Job not found.', 'mainwp' ), |
| 2112 |
array( 'status' => 404 ) |
| 2113 |
); |
| 2114 |
} |
| 2115 |
|
| 2116 |
return rest_ensure_response( |
| 2117 |
array( |
| 2118 |
'success' => 'completed' === $disconnect_data['status'] && 0 === $disconnect_data['failed'], |
| 2119 |
'status' => $disconnect_data['status'], |
| 2120 |
'total' => $disconnect_data['total'], |
| 2121 |
'processed' => $disconnect_data['processed'], |
| 2122 |
'failed' => $disconnect_data['failed'], |
| 2123 |
'progress' => round( ( $disconnect_data['processed'] / $disconnect_data['total'] ) * 100, 2 ), |
| 2124 |
'errors' => ! empty( $disconnect_data['errors'] ) ? array_slice( $disconnect_data['errors'], 0, 10 ) : array(), |
| 2125 |
'started_at' => $disconnect_data['started_at'], |
| 2126 |
'completed_at' => $disconnect_data['completed_at'] ?? null, |
| 2127 |
) |
| 2128 |
); |
| 2129 |
} |
| 2130 |
|
| 2131 |
/** |
| 2132 |
* Clear activation data. |
| 2133 |
* |
| 2134 |
* @param WP_REST_Request $request Full details about the request. |
| 2135 |
* |
| 2136 |
* @uses MainWP_Keys_Manager::instance()->update_key_value() |
| 2137 |
* @uses MainWP_Api_Manager::instance()->get_activation_info() |
| 2138 |
* @uses MainWP_Api_Manager::instance()->set_activation_info() |
| 2139 |
* |
| 2140 |
* @return WP_Error|WP_REST_Response |
| 2141 |
*/ |
| 2142 |
public function clear_activation_data( $request ) { // phpcs:ignore -- NOSONAR - complex. |
| 2143 |
// Clear activation data. |
| 2144 |
delete_option( 'mainwp_extensions_api_username' ); |
| 2145 |
delete_option( 'mainwp_extensions_api_password' ); |
| 2146 |
delete_option( 'mainwp_extensions_api_save_login' ); |
| 2147 |
delete_option( 'mainwp_extensions_plan_info' ); |
| 2148 |
|
| 2149 |
// Clear master api key. |
| 2150 |
MainWP_Keys_Manager::instance()->update_key_value( 'mainwp_extensions_master_api_key', false ); |
| 2151 |
|
| 2152 |
// Clear extension api key. |
| 2153 |
$new_extensions = array(); |
| 2154 |
$extensions = get_option( 'mainwp_extensions', array() ); |
| 2155 |
|
| 2156 |
if ( is_array( $extensions ) ) { |
| 2157 |
foreach ( $extensions as $ext ) { |
| 2158 |
if ( isset( $ext['api'] ) && isset( $ext['apiManager'] ) && ! empty( $ext['apiManager'] ) ) { |
| 2159 |
if ( isset( $ext['api_key'] ) ) { |
| 2160 |
$ext['api_key'] = ''; |
| 2161 |
} |
| 2162 |
if ( isset( $ext['activation_email'] ) ) { |
| 2163 |
$ext['activation_email'] = ''; |
| 2164 |
} |
| 2165 |
if ( isset( $ext['activated_key'] ) ) { |
| 2166 |
$ext['activated_key'] = 'Deactivated'; |
| 2167 |
} |
| 2168 |
|
| 2169 |
$act_info = MainWP_Api_Manager::instance()->get_activation_info( $ext['api'] ); |
| 2170 |
if ( isset( $act_info['api_key'] ) ) { |
| 2171 |
$act_info['api_key'] = ''; |
| 2172 |
} |
| 2173 |
if ( isset( $act_info['activation_email'] ) ) { |
| 2174 |
$act_info['activation_email'] = ''; |
| 2175 |
} |
| 2176 |
if ( isset( $act_info['activated_key'] ) ) { |
| 2177 |
$act_info['activated_key'] = 'Deactivated'; |
| 2178 |
} |
| 2179 |
MainWP_Api_Manager::instance()->set_activation_info( $ext['api'], $act_info ); |
| 2180 |
} |
| 2181 |
$new_extensions[] = $ext; |
| 2182 |
} |
| 2183 |
} |
| 2184 |
|
| 2185 |
MainWP_Utility::update_option( 'mainwp_extensions', $new_extensions ); |
| 2186 |
MainWP_Utility::update_option( 'mainwp_extensions_all_activation_cached', '' ); |
| 2187 |
|
| 2188 |
return rest_ensure_response( |
| 2189 |
array( |
| 2190 |
'success' => 1, |
| 2191 |
'message' => __( 'Activation data cleared successfully.', 'mainwp' ), |
| 2192 |
) |
| 2193 |
); |
| 2194 |
} |
| 2195 |
|
| 2196 |
/** |
| 2197 |
* Restore info messages by clearing the saved notice status. |
| 2198 |
* |
| 2199 |
* @param WP_REST_Request $request Full details about the request. |
| 2200 |
* |
| 2201 |
* @return WP_Error|WP_REST_Response |
| 2202 |
*/ |
| 2203 |
public function restore_info_messages( $request ) { |
| 2204 |
$user_id = $this->get_user_id(); |
| 2205 |
if ( is_wp_error( $user_id ) ) { |
| 2206 |
return $user_id; |
| 2207 |
} |
| 2208 |
|
| 2209 |
// Delete user option. |
| 2210 |
delete_user_option( $user_id, 'mainwp_notice_saved_status' ); |
| 2211 |
|
| 2212 |
return rest_ensure_response( |
| 2213 |
array( |
| 2214 |
'success' => 1, |
| 2215 |
'message' => __( 'Info messages restored successfully.', 'mainwp' ), |
| 2216 |
) |
| 2217 |
); |
| 2218 |
} |
| 2219 |
|
| 2220 |
/** |
| 2221 |
* Get allowed fields for general settings. |
| 2222 |
* |
| 2223 |
* @return array |
| 2224 |
*/ |
| 2225 |
public function get_update_general_allowed_fields() { // phpcs:ignore -- NOSONAR - long method. |
| 2226 |
$val_bool = array( 0, 1 ); |
| 2227 |
$disable_update = array( 0, 1, 2 ); |
| 2228 |
$days_week = range( 0, 6 ); |
| 2229 |
$days_month = range( 0, 31 ); |
| 2230 |
$delay = array( 0, 1, 2, 3, 4, 5, 6, 7, 14, 30 ); |
| 2231 |
$frequency = array( 'daily', 'weekly', 'monthly' ); |
| 2232 |
$frequency_daily = range( 1, 12 ); |
| 2233 |
$http_methods = array( 'head', 'get' ); |
| 2234 |
$archive_format = array( 'zip', 'tar.gz', 'tar.bz2', 'tar' ); |
| 2235 |
$primary_backup = array( '', 'module-api-backups' ); |
| 2236 |
|
| 2237 |
return array( |
| 2238 |
'time_daily_update' => array( |
| 2239 |
'required' => false, |
| 2240 |
'description' => __( 'Time for daily updates (HH:MM format).', 'mainwp' ), |
| 2241 |
'type' => 'string', |
| 2242 |
'validate_callback' => array( $this, 'validate_time_update' ), |
| 2243 |
'sanitize_callback' => array( $this, 'sanitize_time_update' ), |
| 2244 |
), |
| 2245 |
'frequency_daily_update' => array( |
| 2246 |
'required' => false, |
| 2247 |
'description' => __( 'Frequency of daily updates (1-12).', 'mainwp' ), |
| 2248 |
'type' => 'integer', |
| 2249 |
'sanitize_callback' => $this->make_enum_sanitizer( $frequency_daily ), |
| 2250 |
'validate_callback' => $this->make_enum_validator( $frequency_daily ), |
| 2251 |
), |
| 2252 |
'date_format' => array( |
| 2253 |
'required' => false, |
| 2254 |
'description' => __( 'Date format.', 'mainwp' ), |
| 2255 |
'type' => 'string', |
| 2256 |
'sanitize_callback' => 'sanitize_text_field', |
| 2257 |
'validate_callback' => array( $this, 'validate_date_format' ), |
| 2258 |
), |
| 2259 |
'time_format' => array( |
| 2260 |
'required' => false, |
| 2261 |
'description' => __( 'Time format.', 'mainwp' ), |
| 2262 |
'type' => 'string', |
| 2263 |
'sanitize_callback' => 'sanitize_text_field', |
| 2264 |
'validate_callback' => array( $this, 'validate_time_format' ), |
| 2265 |
), |
| 2266 |
'timezone_string' => array( |
| 2267 |
'required' => false, |
| 2268 |
'description' => __( 'Timezone.', 'mainwp' ), |
| 2269 |
'type' => 'string', |
| 2270 |
'sanitize_callback' => array( $this, 'sanitize_timezone_field' ), |
| 2271 |
'validate_callback' => array( $this, 'validate_timezone' ), |
| 2272 |
), |
| 2273 |
'sidebar_position' => array( |
| 2274 |
'required' => false, |
| 2275 |
'description' => __( 'Sidebar position.', 'mainwp' ), |
| 2276 |
'type' => 'boolean', |
| 2277 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2278 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2279 |
), |
| 2280 |
'hide_update_everything' => array( |
| 2281 |
'required' => false, |
| 2282 |
'description' => __( 'Hide update everything button.', 'mainwp' ), |
| 2283 |
'type' => 'boolean', |
| 2284 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2285 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2286 |
), |
| 2287 |
'mainwp_widgets' => array( |
| 2288 |
'required' => false, |
| 2289 |
'description' => __( 'MainWP dashboard widgets.', 'mainwp' ), |
| 2290 |
'type' => 'array', |
| 2291 |
'sanitize_callback' => array( $this, 'sanitize_mainwp_widgets' ), |
| 2292 |
'validate_callback' => array( $this, 'validate_mainwp_widgets' ), |
| 2293 |
), |
| 2294 |
'plugin_automatic_daily_update' => array( |
| 2295 |
'required' => false, |
| 2296 |
'description' => __( 'Plugin automatic daily update.', 'mainwp' ), |
| 2297 |
'type' => 'integer', |
| 2298 |
'enum' => $val_bool, |
| 2299 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2300 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2301 |
), |
| 2302 |
'theme_automatic_daily_update' => array( |
| 2303 |
'required' => false, |
| 2304 |
'description' => __( 'Theme automatic daily update.', 'mainwp' ), |
| 2305 |
'type' => 'integer', |
| 2306 |
'enum' => $val_bool, |
| 2307 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2308 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2309 |
), |
| 2310 |
'trans_automatic_daily_update' => array( |
| 2311 |
'required' => false, |
| 2312 |
'description' => __( 'Translation automatic daily update enabled.', 'mainwp' ), |
| 2313 |
'type' => 'integer', |
| 2314 |
'enum' => $val_bool, |
| 2315 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2316 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2317 |
), |
| 2318 |
'automatic_daily_update' => array( |
| 2319 |
'required' => false, |
| 2320 |
'description' => __( 'Automatic daily update enabled.', 'mainwp' ), |
| 2321 |
'type' => 'integer', |
| 2322 |
'enum' => $val_bool, |
| 2323 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2324 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2325 |
), |
| 2326 |
'frequency_auto_update' => array( |
| 2327 |
'required' => false, |
| 2328 |
'description' => __( 'Frequency of auto updates.', 'mainwp' ), |
| 2329 |
'type' => 'string', |
| 2330 |
'sanitize_callback' => $this->make_enum_sanitizer( $frequency, 'string' ), |
| 2331 |
'validate_callback' => $this->make_enum_validator( $frequency, 'string' ), |
| 2332 |
), |
| 2333 |
'time_auto_update' => array( |
| 2334 |
'required' => false, |
| 2335 |
'description' => __( 'Auto update time (whole hour, 24h).', 'mainwp' ), |
| 2336 |
'type' => 'string', |
| 2337 |
'validate_callback' => array( $this, 'validate_time_update' ), |
| 2338 |
'sanitize_callback' => array( $this, 'sanitize_time_update' ), |
| 2339 |
), |
| 2340 |
'show_language_updates' => array( |
| 2341 |
'required' => false, |
| 2342 |
'description' => __( 'Show language updates.', 'mainwp' ), |
| 2343 |
'type' => 'boolean', |
| 2344 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2345 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2346 |
), |
| 2347 |
'disable_update_confirmations' => array( |
| 2348 |
'required' => false, |
| 2349 |
'description' => __( 'Disable update confirmations.', 'mainwp' ), |
| 2350 |
'type' => 'integer', |
| 2351 |
'sanitize_callback' => $this->make_enum_sanitizer( $disable_update ), |
| 2352 |
'validate_callback' => $this->make_enum_validator( $disable_update ), |
| 2353 |
), |
| 2354 |
'check_http_response' => array( |
| 2355 |
'required' => false, |
| 2356 |
'description' => __( 'Check HTTP response after update.', 'mainwp' ), |
| 2357 |
'type' => 'boolean', |
| 2358 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2359 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2360 |
), |
| 2361 |
'check_http_response_method' => array( |
| 2362 |
'required' => false, |
| 2363 |
'description' => __( 'HTTP method for response check.', 'mainwp' ), |
| 2364 |
'type' => 'string', |
| 2365 |
'sanitize_callback' => $this->make_enum_sanitizer( $http_methods, 'string' ), |
| 2366 |
'validate_callback' => $this->make_enum_validator( $http_methods, 'string' ), |
| 2367 |
), |
| 2368 |
'backup_before_upgrade' => array( |
| 2369 |
'required' => false, |
| 2370 |
'description' => __( 'Backup before upgrade.', 'mainwp' ), |
| 2371 |
'type' => 'boolean', |
| 2372 |
'sanitize_callback' => $this->make_enum_sanitizer( $val_bool ), |
| 2373 |
'validate_callback' => $this->make_enum_validator( $val_bool ), |
| 2374 |
), |
| 2375 |
'backup_before_upgrade_days' => array( |
| 2376 |
'required' => false, |
| 2377 |
'description' => __( 'Days to check for backup before upgrade.', 'mainwp' ), |
| 2378 |
'type' => 'integer', |
| 2379 |
'sanitize_callback' => 'absint', |
| 2380 |
), |
| 2381 |
'numberdays_outdate_plugin_theme' => array( |
| 2382 |
'required' => false, |
| 2383 |
'description' => __( 'Number of days to consider plugin/theme as outdated.', 'mainwp' ), |
| 2384 |
'type' => 'integer', |
| 2385 |
'sanitize_callback' => 'absint', |
| 2386 |
), |
| 2387 |
'dayinweek_auto_update' => array( |
| 2388 |
'required' => false, |
| 2389 |
'description' => __( 'Day in week for auto updates.', 'mainwp' ), |
| 2390 |
'type' => 'integer', |
| 2391 |
'sanitize_callback' => $this->make_enum_sanitizer( $days_week ), |
| 2392 |
'validate_callback' => $this->make_enum_validator( $days_week ), |
| 2393 |
), |
| 2394 |
'dayinmonth_auto_update' => array( |
| 2395 |
'required' => false, |
| 2396 |
'description' => __( 'Day in month for auto updates.', 'mainwp' ), |
| 2397 |
'type' => 'integer', |
| 2398 |
'sanitize_callback' => $this->make_enum_sanitizer( $days_month ), |
| 2399 |
'validate_callback' => $this->make_enum_validator( $days_month ), |
| 2400 |
), |
| 2401 |
'delay_autoupdate' => array( |
| 2402 |
'required' => false, |
| 2403 |
'description' => __( 'Delay automatic updates.', 'mainwp' ), |
| 2404 |
'type' => 'integer', |
| 2405 |
'sanitize_callback' => $this->make_enum_sanitizer( $delay ), |
| 2406 |
'validate_callback' => $this->make_enum_validator( $delay ), |
| 2407 |
), |
| 2408 |
'mainwp_primary_backup' => array( |
| 2409 |
'required' => false, |
| 2410 |
'description' => __( 'Primary backup method.', 'mainwp' ), |
| 2411 |
'type' => 'string', |
| 2412 |
[...]
